/**
*	Javascript for receiving stock
*/

var base_url = '';
var print_prompt = false;

function receive_setup(url) {
	base_url = url;

	if(print_prompt) {
		window.onbeforeunload = print_confirm;
	}
}

function print_confirm() {
	alert(print_prompt);
	return false;
}

function get_serials(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	} else if (e.id) {
		var target = e;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parent;
	}
	var base_id = target.id.replace(/\[serials\]/gi, '');
	var purchase_order_id = document.getElementById(base_id + '[purchase_order_id]');
	var shipment_id = document.getElementById(base_id + '[shipment_id]');
	var quantity = document.getElementById(base_id + '[received]');
	var line_no = document.getElementById(base_id + '[line_no]');
	var serials = document.getElementById(base_id + '[serial_numbers]');

	var url = base_url + '/index.php?menuaction=perp_ap.ui_perp_receive.receive_serials';
	if(purchase_order_id) {
		url += '&purchase_order_id=' + purchase_order_id.value;
	}
	if(shipment_id) {
		url += '&shipment_id=' + shipment_id.value;
	}
	if(quantity) {
		url += '&quantity=' + quantity.value;
	}
	if(line_no) {
		url += '&line_no=' + line_no.value;
	}
	if(base_id) {
		url += '&base_id=' + base_id;
	}
	if(serials) {
		url += '&serial_numbers=' + serials.value;
	}

	if(quantity && quantity.value > 0) {
		window.open(url,'_blank','dependent=yes,width=600,height=450,scrollbars=yes,status=yes');
	} else {
		alert('None to receive.  Please enter a quantity first.');
	}
	return false;
}


