<?php
	/**************************************************************************\
	* pERP - perp_ap                                                     	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_ap']['name']      = 'perp_ap';
	$setup_info['perp_ap']['version']   = '0.2.011';
	$setup_info['perp_ap']['app_order'] = 12;
	$setup_info['perp_ap']['enable']    = 1;

	$setup_info['perp_ap']['author'] = 'Nathan Gray';
 	$setup_info['perp_ap']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_ap']['license']  = 'GPL';
	$setup_info['perp_ap']['description'] = 'Accounts Payable module for ERP';
	$setup_info['perp_ap']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_ap']['hooks']['preferences'] = 'perp_ap.hook_perp_ap.preference_menu';
	$setup_info['perp_ap']['hooks'][] = 'settings';
	$setup_info['perp_ap']['hooks']['admin'] = 'perp_ap.hook_perp_ap.admin_hook';
	$setup_info['perp_ap']['hooks']['search_link'] = 'perp_ap.hook_perp_ap.search_link';
	$setup_info['perp_ap']['hooks']['sidebox_menu'] = 'perp_ap.hook_perp_ap.sidebox';
	$setup_info['perp_ap']['hooks'][] = 'home';//] = 'perp_ap.hook_perp_ap.home';
	

	/* Dependencies for this app to work */
	$setup_info['perp_ap']['depends'][] = array(
		 'appname' => 'perp_api',
		 'versions' => Array('0.1', '0.2', '1.0')
	);
	$setup_info['perp_ap']['depends'][] = array(
		 'appname' => 'perp_ledger',
		 'versions' => Array('0.1', '0.2', '1.0')
	);

	$setup_info['perp_ap']['tables'] = array('perp_supplier','perp_supplier_ledger','perp_purchase_order','perp_purchase_order_detail','perp_supplier_stock','perp_goods_received','perp_payable_invoice','perp_supplier_payment','perp_supplier_ship_package','perp_receiving_not_ordered','perp_payment_reversal');

