<?php

/**
*	@mainpage projectERP
*
*	@section Introduction
*	pERP is an eGroupWare ERP Group of Modules, mostly geared towards manufacturing, but very configurable. 
*
*	@see http://projecterp.org
*/

/**
*	@package perp_api
*
*	@brief Common data and functions
*	
*	perp_api provides:
*		- Units of Measure
*		- Shipper list
*		- Currency list
*		- Payment Terms
*		- Payment Types
*		- Taxes
*		
*		- Configuration framework
*		- ACL framework
*		- Message formatting
*		- Report framework
*
*	@author Nathan Gray
*       @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
*/

/**
*	@defgroup perp_api pERP API
*/

	$GLOBALS['egw_info']['flags'] = array(
		'currentapp'	=>	'perp_api',
		'noheader'	=>	True,
		'nonavbar'	=>	True,
	);

	include('../header.inc.php');
	
?>
