<?php

	$GLOBALS['egw']->translation->add_app('perp_ar');

	$span = array(
		'1'	=>	'Today',
		'7'	=>	'This week',
		'mine'	=>	'For my stuff',
	);

	$app_id = $GLOBALS['egw']->applications->name2id('perp_ar');
	$GLOBALS['portal_order'][] = $app_id;
	$old_app = $GLOBALS['egw_info']['flags']['currentapp'];
	$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_ar';
	$portalbox =& CreateObject('phpgwapi.listbox', array(
		'title'		=>	lang('perp_ar'),
		'primary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'secondary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'tertiary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'width'		=>	'100%',
		'outerborderwidth' => '0',
		'header_background_image' => $GLOBALS['egw']->common->image('phpgwapi/templates/default','bg_filler')
	));

	$portalbox->data = $data;
	foreach(array('up','down','close','question','edit') as $key) {
		$portalbox->set_controls($key,Array('url' => '/set_box.php', 'app' => $app_id));
	}
	$html = '<table width="100%"><tbody><tr style="vertical-align: top;">';

	if(($show_shipment = $GLOBALS['egw_info']['user']['preferences']['perp_ar']['homepage_display_outgoing_shipments'])) {
		
		$shipments = array();
		$readonly = array();
		$boshipment = CreateObject('perp_ar.bo_perp_outgoing_shipment');

		$query['status'] = 'pending';
		$query['template'] = false;
		$query['show_sales_orders'] = True;
		$pending_readonly = array();
		$boshipment->get_shipment_list($query, $pending, $pending_readonly);

		$query['status'] = 'overdue';
		$overdue_readonly = array();
		$boshipment->get_shipment_list($query, $overdue, $overdue_readonly);

		$query['status'] = 'approved';
		$approved_readonly = array();
		$boshipment->get_shipment_list($query, $data, $approved_readonly);
		$shipments += $pending + $overdue;
		$readonly += $pending_readonly + $overdue_readonly + $approved_readonly;

		foreach($shipments as $key => $row) {
			if(is_integer($show_shipment)) {
				if($row['eta'] > mktime(0,0,0, date('m'), date('d') + $show_shipment, date('Y'))) {
					unset($data[$key]);
				}
			} elseif ($show_shipment == 'mine') {
				$mine = True;
				if(!$mine) {
					unset($data[$key]);
				}
			}
		}

		if(count($shipments) > 0) {
			array_unshift($shipments, false);
			$data['nextmatch']['rows'] = $shipments;
			$readonly_array['nextmatch']['rows'] = $readonly;
			$html .= '</tr><tr><td colspan="2">';
			$data['span'] = $span[$show_shipment];
			$select_box_options['shipper'] = ExecMethod('perp_api.bo_perp_api.get_shippers');
			$select_box_options['location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$s_template = CreateObject('etemplate.etemplate');
			$s_template->read('perp_ar.home.shipments');
			$html .= $s_template->exec('perp_ar.ui_perp_outgoing_shipment.shipment_list', $data, $select_box_options, $readonly_array, null, -1);
			$html .= '</td>';
		}
	}

	if(($show_invoices = (int)$GLOBALS['egw_info']['user']['preferences']['perp_ar']['homepage_display_upcoming_payments']) > 0) {
		$due = array();
		$overdue = array();
		$due_readonly = array();
		$overdue_readonly = array();

		$boinvoice = CreateObject('perp_ar.bo_perp_receivable_invoice');
		$boinvoice->get_invoice_list(array('status' => 'due', 'template' => false), $due, $due_readonly);
		$boinvoice->get_invoice_list(array('filter' => 'overdue', 'template' => false), $overdue, $overdue_readonly);
		foreach($due as $key => $row) {
			if(is_numeric($key) && ($row['due_date'] > date('U', mktime(0,0,0, date('m'), date('d') + $show_invoices, date('Y'))))) {
				unset($due[$key]);
			}
		}
		$invoices = array_merge($due, $overdue);
		$readonly['nextmatch']['rows'] = array_merge($due_readonly, $overdue_readonly);

		$data = array();
		foreach($invoices as $key => &$value) {
			if(!is_numeric($key)) {
				continue;
			}
			$value += array(
				'invoice_id'	=>	$value['invoice_id'],
				'our_reference'	=>	$value['our_reference_number'],
				'their_reference'	=>	$value['their_reference_number'],
				'due_date'	=>	$value['due_date'],
			);
		}

		if(count($invoices) > 0) {
			array_unshift($invoices, false);
			$data['nextmatch']['rows'] = $invoices;
			$data['span'] = $span[$show_invoices];
			$html .= '</tr><tr><td colspan="2">';
			$i_template = CreateObject('etemplate.etemplate');
			$i_template->read('perp_ar.home.invoices');
			$html .= $i_template->exec('perp_ar.ui_perp_receivable_invoice.invoice_list', $data, $select_box_options, $readonly, null, -1);
			$html .= '</td>';
		}
	}

	$html .= '</tr></tbody></table>';

	if (!file_exists(EGW_SERVER_ROOT.($css_file ='/perp_ar/templates/'.$GLOBALS['egw_info']['user']['preferences']['common']['template_set'].'/app.css'))) {
		$css_file = '/perp_ar/templates/default/app.css';
	}
	$GLOBALS['egw_info']['flags']['currentapp'] = $old_app;
        echo '
<style type="text/css">
<!--
        @import url('.$GLOBALS['egw_info']['server']['webserver_url'].$css_file.');
-->
</style>';
	echo $portalbox->draw($html);
	
?>
