/**
*	Javascript for getting serial numbers
*/

var base_url = '';

/**
 * 	@param url The base URL of the system
 */
function serial_setup(url) {
	base_url = url;
}

function get_serials(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	} else if (e.id) {
		var target = e;
	}
	if (target && target.nodeType == 3) { // defeat Safari bug
		target = target.parent;
	}

	var base_id = target.id.replace(/\[serials\]/gi, '');
	var stock_id = document.getElementById(base_id + '[stock_id]');
	var quantity = document.getElementById(base_id + '[container_quantity]');
	var serials = document.getElementById(base_id + '[serial_numbers]');

	var url = base_url + '/index.php?menuaction=perp_inventory.ui_perp_inventory.move_serial';
	url += '&button_id=' + target.id;
	if(stock_id) {
		url += '&stock_id=' + stock_id.value;
	}
	if(quantity) {
		url += '&quantity=' + quantity.value;
	}
	if(base_id) {
		url += '&base_id=' + base_id;
	}
	if(serials) {
		url += '&serials=' + serials.value;
	}

	if(quantity && quantity.value > 0) {
		window.open(url,'_blank','dependent=yes,width=600,height=450,scrollbars=yes,status=yes');
	} else {
		alert('No stock to move');
	}
	return false;
}
