/* Javascript for editing shipment order */

function change_client(e){

	if (!e) {
		var e = window.event;
	}
	if (!e) {
		return;
	}
	else 
		if (e.target) {
			var target = e.target;
		}
		else 
			if (e.srcElement) {
				var target = e.srcElement;
			}
	
	
	if (target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	}
	else {
		var target = e;
	}
	
	var client_id = target.value;	
	var client_branch = document.getElementById('exec[client_branch_id][results]');
	
	if (client_branch) {
		client_branch.options.client_id = client_id;
	}
	else {
		return false;
	}

	xajax_doXMLHTTP("perp_ar.ajax_perp_outgoing_shipment.change_client", client_id);
	
}
	
function change_branch(e) {
	
	if(!e) {
		var e = window.event;
	}
	if(!e) {
		return;
	} else if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	} else {
		var target = e;
	}
	var client_id = document.getElementById('exec[client_id][value]');
	if(client_id) {
		client_id = client_id.value;
	} else {
		return false;
	}
	var client_branch_id = target.value;

	xajax_doXMLHTTP("perp_ar.ajax_perp_outgoing_shipment.change_client_branch", client_id, client_branch_id);
	
	
}

/* Remove options from a select box
*  @param id - The id of the select
*/
function removeOptions(id) {
	if(document.getElementById(id)) {
		var element = document.getElementById(id);
		if(element.options) {
			while(element.options.length > 0) {
				element.remove(0);
			}
		}
	}



}
