<?php
	/**************************************************************************\
	* pERP - perp_ar                                                     	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_ar']['name']      = 'perp_ar';
	$setup_info['perp_ar']['version']   = '0.2.006';
	$setup_info['perp_ar']['app_order'] = 15;
	$setup_info['perp_ar']['enable']    = 1;

	$setup_info['perp_ar']['author'] = 'Nathan Gray';
 	$setup_info['perp_ar']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_ar']['license']  = 'GPL';
	$setup_info['perp_ar']['description'] = 'Accounts Receivalbe module for pERP';
	$setup_info['perp_ar']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_ar']['hooks']['preferences'] = 'perp_ar.hook_perp_ar.preference_menu';
	$setup_info['perp_ar']['hooks'][] = 'settings';
	$setup_info['perp_ar']['hooks']['admin'] = 'perp_ar.hook_perp_ar.admin_hook';
	$setup_info['perp_ar']['hooks']['search_link'] = 'perp_ar.hook_perp_ar.search_link';
	$setup_info['perp_ar']['hooks']['sidebox_menu'] = 'perp_ar.hook_perp_ar.sidebox';
	$setup_info['perp_ar']['hooks'][] = 'home';//] = 'perp_ar.hook_perp_ar.home';
	
	// Don't override projectmanager if it implements invoicable hooks
	//if(is_object($GLOBALS['egw']->hooks) && !$GLOBALS['egw']->hooks->found_hooks['projectmanager']['perp_ar:invoicable']) {
		$setup_info['projectmanager']['hooks']['perp_ar:invoicable'] = 'perp_ar.hook_perp_ar.ProjectManagerInvoicable_hook';
	//}
	// Don't override timesheet if it implements invoicable hooks
	//if(is_object($GLOBALS['egw']->hooks) && !$GLOBALS['egw']->hooks->found_hooks['timesheet']['perp_ar:invoicable']) {
		$setup_info['timesheet']['hooks']['perp_ar:invoicable'] = 'perp_ar.hook_perp_ar.TimesheetInvoicable_hook';
	//}

	/* Dependencies for this app to work */
	$setup_info['perp_ar']['depends'][] = array(
		 'appname' => 'perp_api',
		 'versions' => Array('0.1', '0.2', '1.0')
	);
	$setup_info['perp_ar']['depends'][] = array(
		 'appname' => 'perp_ledger',
		 'versions' => Array('0.1', '0.2', '1.0')
	);

	$setup_info['perp_ar']['tables'] = array('perp_client','perp_client_ledger','perp_client_branch','perp_hold_reason','perp_client_account','perp_client_shipment','perp_client_account_price_list','perp_client_account_discount','perp_client_receipt','perp_receivable_invoice','perp_outgoing_shipment_package','perp_receipt_reversal');






