<?php
	
	require_once('class.bo_perp_staff.inc.php');

	class bo_perp_human_resources {
		public function link_query($param) {
			$bo_staff = new bo_perp_staff();
			return $bo_staff->link_query($param);
		}

		/**
		*	Get title for an employee identified by $entry
		*	Called as hook to participate in linking
		*
		*	@param int/array $entry staff_id
		*	@return string Title or false
		*/
		public static function link_title($entry) {
			list($location, $id) = explode('-', $entry, 2);
			switch ($location) {
				case 'STAFF':
					return bo_perp_staff::link_title($id);
					break;
				default:
					throw new egw_exception('Unknown link key: ' . $location);
			}
		}
	}
?>
