<?php
	/**************************************************************************\
	* pERP - perp_human_resources                                          	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/

	$setup_info['perp_human_resources']['name']	=	'perp_human_resources';
	$setup_info['perp_human_resources']['version']   = '0.1.022';
	$setup_info['perp_human_resources']['app_order'] = 18;
	$setup_info['perp_human_resources']['enable']    = 1;

	$setup_info['perp_human_resources']['author'] = 'Nathan Gray';
 	$setup_info['perp_human_resources']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_human_resources']['license']  = 'GPL';
	$setup_info['perp_human_resources']['description'] = 'Human Resources module for pERP';
	$setup_info['perp_human_resources']['note'] = 'In progress, just a framework for now';

	/* The hooks this app includes, needed for hooks registration */
	/*
	$setup_info['perp_human_resources']['hooks']['preferences'] = '';
	$setup_info['perp_human_resources']['hooks'][] = 'settings';
	*/
	$setup_info['perp_human_resources']['hooks']['admin'] = 'perp_human_resources.hook_perp_human_resources.admin_hook';
	$setup_info['perp_human_resources']['hooks']['search_link'] = 'perp_human_resources.hook_perp_human_resources.search_link';
	$setup_info['perp_human_resources']['hooks']['sidebox_menu'] = 'perp_human_resources.hook_perp_human_resources.sidebox';
	$setup_info['perp_human_resources']['hooks'][] = 'home';

	/**
	*	Dependencies for this app to work 
	*/
	$setup_info['perp_human_resources']['depends'][] = array(
		 'appname' => 'perp_api',
		 'versions' => Array('0.1', '0.2', '1.0')
	);
	$setup_info['perp_human_resources']['depends'][] = array(
		 'appname' => 'perp_ledger',
		 'versions' => Array('0.1', '0.2', '1.0')
	);

	$setup_info['perp_human_resources']['tables'] = array('perp_staff','perp_staff_authentication','perp_staff_skill','perp_staff_department','perp_record_of_employment','perp_staff_extra');


