<?php

	/**
	 * eGroupWare - Setup
	 * http://www.egroupware.org 
	 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
	 *
	 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
	 * @package perp_human_resources
	 * @subpackage setup
	 * @version $Id: class.db_tools.inc.php 21408 2006-04-21 10:31:06Z nelius_weiss $
	 */

	$test[] = '0.0.1';
	function perp_human_resources_upgrade0_0_1()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_authentication',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'authentication_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'authentication_data' => array('type' => 'blob','nullable' => False)
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.0.002';
	}


	$test[] = '0.0.002';
	function perp_human_resources_upgrade0_0_002()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_skill',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'skill_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'skill_start_date' => array('type' => 'date','nullable' => False),
				'skill_expiry_date' => array('type' => 'date'),
				'skill_level' => array('type' => 'int','precision' => '2')
			),
			'pk' => array(),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.0.003';
	}


	$test[] = '0.0.003';
	function perp_human_resources_upgrade0_0_003()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_department',array(
			'fd' => array(
				'department_id' => array('type' => 'auto'),
				'department_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'department_manager' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('department_id'),
			'fk' => array('department_manager' => 'perp_staff.staff_id','group_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.0.004';
	}


	$test[] = '0.0.004';
	function perp_human_resources_upgrade0_0_004()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff','status',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.0.005';
	}


	$test[] = '0.1.005';
	function perp_human_resources_upgrade0_1_005()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_department','department_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_department',array(
			'fd' => array(
				'department_id' => array('type' => 'int','precision' => '4'),
				'department_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'department_manager' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('department_id'),
			'fk' => array('department_manager' => 'perp_staff.staff_id','group_id' => 'egw_accounts.account_id','department_id' => 'perp_staff_department.department_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function perp_human_resources_upgrade0_1_006()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_department','department_id',array(
			'type' => 'auto',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_department','department_parent',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_department',array(
			'fd' => array(
				'department_id' => array('type' => 'auto','precision' => '4'),
				'department_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'department_manager' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4'),
				'department_parent' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('department_id'),
			'fk' => array('department_manager' => 'perp_staff.staff_id','group_id' => 'egw_accounts.account_id','department_parent' => 'perp_staff_department.department_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function perp_human_resources_upgrade0_1_007()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_authentication','staff_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_authentication','authentication_type',array(
			'type' => 'varchar',
			'precision' => '20',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_authentication',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'authentication_type' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'authentication_data' => array('type' => 'blob','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function perp_human_resources_upgrade0_1_008()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_authentication',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'authentication_type' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'authentication_data' => array('type' => 'blob','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array('authentication_data')
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function perp_human_resources_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->db->select('perp_staff',
			array('staff_id', 'user_id'),
			array(),
			__LINE__, __FILE__
		);
		$staff = array();
		while($row = $GLOBALS['egw_setup']->db->row(true)) {
			$staff[$row['staff_id']] = $row['user_id'];
		}
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff','staff_id','employee_number');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff','employee_number',array(
			'type' => 'varchar',
			'precision' => '20',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff',array(
			'fd' => array(
				'employee_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date'),
				'status' => array('type' => 'int','precision' => '1','nullable' => False),
				'department_id' => array('type' => 'int','precision' => '4'),
				'reports_to' => array('type' => 'int','precision' => '4'),
				'user_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('user_id'),
			'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		foreach($staff as $staff_id => $user_id) {
			$tables = array(
				'perp_staff_authentication'	=>	'staff_id',
				'perp_staff_department'		=>	'department_manager',
				'perp_timecard'			=>	'staff_id'
			);
			foreach($tables as $table => $field) {
				$update = "UPDATE $table SET $field = $user_id WHERE $field = $staff_id";
				$GLOBALS['egw_setup']->db->query($update);
			}
		}
		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function perp_human_resources_upgrade0_1_010()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_authentication','staff_id','user_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_authentication',array(
			'fd' => array(
				'user_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'authentication_type' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'authentication_data' => array('type' => 'blob','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array('authentication_data')
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function perp_human_resources_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_skill','staff_id','user_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_skill',array(
			'fd' => array(
				'user_id' => array('type' => 'int','precision' => '4'),
				'skill_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'skill_start_date' => array('type' => 'date','nullable' => False),
				'skill_expiry_date' => array('type' => 'date'),
				'skill_level' => array('type' => 'int','precision' => '2')
			),
			'pk' => array(),
			'fk' => array('user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function perp_human_resources_upgrade0_1_012()
	{


		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_department',array(
			'fd' => array(
				'department_id' => array('type' => 'auto','precision' => '4'),
				'department_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'department_manager' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4'),
				'department_parent' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('department_id'),
			'fk' => array('department_manager' => 'egw_accounts.account_id','group_id' => 'egw_accounts.account_id','department_parent' => 'perp_staff_department.department_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function perp_human_resources_upgrade0_1_013()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_department','department_number',array(
			'type' => 'varchar',
			'precision' => '20'
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function perp_human_resources_upgrade0_1_014()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_skill','skill_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_skill',array(
			'fd' => array(
				'user_id' => array('type' => 'int','precision' => '4'),
				'skill_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'skill_start_date' => array('type' => 'date','nullable' => False),
				'skill_expiry_date' => array('type' => 'date'),
				'skill_level' => array('type' => 'int','precision' => '2'),
				'skill_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('user_id','skill_id'),
			'fk' => array('user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function perp_human_resources_upgrade0_1_015()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_staff',array(
			'fd' => array(
				'employee_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'end_date' => array('type' => 'date'),
				'status' => array('type' => 'int','precision' => '1','nullable' => False),
				'department_id' => array('type' => 'int','precision' => '4'),
				'reports_to' => array('type' => 'int','precision' => '4'),
				'user_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('user_id'),
			'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		),'start_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_staff',array(
			'fd' => array(
				'employee_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'status' => array('type' => 'int','precision' => '1','nullable' => False),
				'department_id' => array('type' => 'int','precision' => '4'),
				'reports_to' => array('type' => 'int','precision' => '4'),
				'user_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('user_id'),
			'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		),'end_date');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff','user_id','staff_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff',array(
			'fd' => array(
				'employee_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'status' => array('type' => 'int','precision' => '1','nullable' => False),
				'department_id' => array('type' => 'int','precision' => '4'),
				'reports_to' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('staff_id'),
			'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','staff_id' => 'egw_addressbook.contact_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function perp_human_resources_upgrade0_1_016()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_record_of_employment',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date'),
				'reason' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function perp_human_resources_upgrade0_1_017()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff','pay_schedule',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff',array(
			'fd' => array(
				'employee_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'status' => array('type' => 'int','precision' => '1','nullable' => False),
				'department_id' => array('type' => 'int','precision' => '4'),
				'reports_to' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'pay_schedule' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('staff_id'),
			'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','staff_id' => 'egw_addressbook.contact_id','pay_schedule' => 'egw_pay_schedule.schedule_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function perp_human_resources_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_skill','user_id','staff_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_skill',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'skill_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'skill_start_date' => array('type' => 'date','nullable' => False),
				'skill_expiry_date' => array('type' => 'date'),
				'skill_level' => array('type' => 'int','precision' => '2'),
				'skill_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('staff_id','skill_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function perp_human_resources_upgrade0_1_019()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_authentication','user_id','staff_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_authentication',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'authentication_type' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'authentication_data' => array('type' => 'blob','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array('authentication_data')
		));

		return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.020';
	}


function perp_human_resources_upgrade0_1_020()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff','gender',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False,
		'default' => '1'
	));

	return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.021';
}


function perp_human_resources_upgrade0_1_021()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_extra',array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'staff_extra_name' => array('type' => 'varchar','precision' => '64'),
			'staff_extra_value' => array('type' => 'text')
		),
		'pk' => array('staff_id','staff_extra_name'),
		'fk' => array('staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_human_resources']['currentver'] = '0.1.022';
}

