<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_location.inc.php');

	/**
	*	Shows locations.
	*	
	*	This report contains one line per stock item, and one column per location.  Columns show
	*	quantity available, with one grand total column and one total column per main location.
	*/

	class location_list extends perp_report {

		public function __construct(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_inventory';
			parent::perp_report($parameters);
			$this->template = 'location_list.odt';

			$this->parameters = $parameters;
		}

		public function get_data($query = array()) {

			$location_bo = new bo_perp_location();

			$location_bo->get_location_list(
				array(
					'template'	=>	false
				),
				$location_list
			);

			// Data
			$data = array(
				'location'	=>	$location_list,
			);
			return $data;
		}
	}
?>
