<?php
	/**************************************************************************\
	* pERP - perp_inventory                                                    *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_inventory']['name']      = 'perp_inventory';
	$setup_info['perp_inventory']['version']   = '0.2.045';
	$setup_info['perp_inventory']['app_order'] = 13;
	$setup_info['perp_inventory']['enable']    = 1;

	$setup_info['perp_inventory']['author'] = 'Nathan Gray';
 	$setup_info['perp_inventory']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_inventory']['license']  = 'GPL';
	$setup_info['perp_inventory']['description'] = 'Inventory Management and Manufacturing System';
	$setup_info['perp_inventory']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_inventory']['hooks']['preferences'] = 'perp_inventory.hook_perp_inventory.preference_menu';
	$setup_info['perp_inventory']['hooks'][] = 'settings';
	$setup_info['perp_inventory']['hooks']['admin'] = 'perp_inventory.hook_perp_inventory.admin_hook';
	$setup_info['perp_inventory']['hooks']['sidebox_menu'] = 'perp_inventory.hook_perp_inventory.sidebox';
	$setup_info['perp_inventory']['hooks']['search_link'] = 'perp_inventory.hook_perp_inventory.search_link';


	/* Dependencies for this app to work */
	$setup_info['perp_inventory']['depends'][] = array(
		 'appname' => 'perp_ap',
		 'versions' => Array('0.1', '0.2')
	);

	$setup_info['perp_inventory']['tables'] = array('perp_stock','perp_location','perp_location_stock','perp_location_transfer','perp_stock_serial','perp_fifo_costing','perp_location_gl_account','perp_stock_tax_category','perp_stock_cost','perp_stock_ship_package','perp_stock_barcode','perp_stock_move','perp_stock_count_sheet','perp_stock_count','perp_stock_count_detail','perp_stock_damage','perp_stock_history','perp_stock_count_serial','perp_stock_serial_pattern','perp_stock_gl_account','perp_stock_category');







