<?php
	/**************************************************************************\
	* pERP - Setup                                                             *
	* http://pERP.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


	$phpgw_baseline = array(
		'perp_stock' => array(
			'fd' => array(
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'min_on_hand' => array('type' => 'int','precision' => '4'),
				'status' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'C'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'volume' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id')
		)
	);
