<?php
	/**
	*	@package perp_ledger
	*	@defgroup perp_ledger pERP Ledger (General Ledger)
	*	@brief	Basis for all financial aspects of pERP
	*	@author Nathan Gray
	*
	*	perp_ledger provides:
	*	- General Ledger Accounts, groups and transactions
	*	- Bank Accounts and functions
	*	- Transaction Types
	*	- Year end
	*/
	$GLOBALS['egw_info']['flags'] = array(
		'currentapp'	=>	'perp_ledger',
		'noheader'	=>	True,
		'nonavbar'	=>	True,
	);

	include('../header.inc.php');
	
	ExecMethod('perp_ledger.ui_perp_ledger.index');

	$GLOBALS['egw']->common->egw_exit();
?>
