<?php
/**
*	@package perp_manufacturing
*
*	@brief Package to transform stock
*	
*	Manufacturing includes:
*		- the ability to generate and track work orders and batch orders
*		- product tracking from the Work Order through various stages of Production to Finished Goods
*		- Bill of Materials that will handle various levels of subassemblies with options
*
*	@author Nathan Gray
*
*	@license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
*/
	$GLOBALS['egw_info']['flags'] = array(
		'currentapp'	=>	'perp_manufacturing',
		'noheader'	=>	True,
		'nonavbar'	=>	True,
	);

	include('../header.inc.php');
	
	ExecMethod('perp_manufacturing.ui_perp_manufacturing.index');

	$GLOBALS['egw']->common->egw_exit();
?>
