<?php
	$locations = array(
		'acl'		=>	5, 
		'work_order'	=>	15,
		'bill_of_material'	=>	15,
		'work_center'	=>	15,
		'build_option'	=>	15,
		'production'	=>	15,
		'retrofit'	=>	7,
	);

	$application = 'perp_manufacturing';
	// We assume that Admins group is group #2
	$admin = -2;
	foreach ($locations as $location => $rights) {
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', 0,$rights)");

		// Give admin rights to everything
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', $admin,$rights)");
	}

	// Give admin run rights
	$GLOBALS['egw_setup']->add_acl($application, 'run', $admin);
	

	// Create a default serial numbering scheme
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_nextid (appname, id) VALUES ('perp_serial:1', 1)");
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_serial_setup (setup_id, name, pattern) VALUES ('1', '" . lang('Default') . "'%1$05d')");


	if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
		// These tables need to be InnoDB
		$transaction_tables = array(
			'perp_work_order',
			'perp_work_order_detail',
			'perp_work_order_option',
			'perp_stock_assembly_serial',
			'perp_serial_setup',
			'egw_wf_agent_perp_build',
		);
		$so_perp_api = CreateObject('perp_api.so_perp_api');
		$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, $transaction_tables);
	}
?>
