<?php


// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

	$test[] = '0.1.000';
	function perp_manufacturing_upgrade0_1_000() {
		$locations = array(
			'acl'			=>	5, 
			'stock_history'		=>	3,
			'work_order'		=>	15,
			'bill_of_material'	=>	15,
			'work_center'		=>	15,
			'build_option'		=>	15,
			'production'		=>	15,
		);

		$application = 'perp_manufacturing';
		// We assume that Admins group is group #2
		$admin = -2;
		foreach ($locations as $location => $rights) {
			$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', 0,$rights)");

			// Give admin rights to everything
			$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', $admin,$rights)");
		}
		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.001';
	}



	$test[] = '0.1.001';
	function perp_manufacturing_upgrade0_1_001()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_work_order_bill_of_material','bom_or_stock','work_center_id');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_bill_of_material','work_center_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id','component'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','component' => 'perp_stock.stock_id','work_center_id' => 'perp_work_center.work_center_id'),
			'ix' => array('work_order_id','detail_id','work_center_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.002';
	}


	$test[] = '0.1.002';
	function perp_manufacturing_upgrade0_1_002()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_work_order_detail','bill_of_material_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_detail',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'option_search' => array('type' => 'text'),
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id','bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id'),
			'ix' => array('work_order_id','detail_id','bill_of_material_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.003';
	}



	$test[] = '0.1.003';
	function perp_manufacturing_upgrade0_1_003()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'auto','nullable' => False),
				'build_option_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'effective_after_date' => array('type' => 'date','nullable' => False),
				'effective_to_date' => array('type' => 'date')
			),
			'pk' => array('build_option_id'),
			'fk' => array('build_option_category' => 'perp_build_option_category.build_option_category_id'),
			'ix' => array('build_option_id','build_option_category','effective_after_date','effective_to_date'),
			'uc' => array('build_option_id')
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.004';
	}


	$test[] = '0.1.004';
	function perp_manufacturing_upgrade0_1_004()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_detail',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'option_search' => array('type' => 'text'),
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id','bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id'),
			'ix' => array('bill_of_material_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.005';
	}


	$test[] = '0.1.005';
	function perp_manufacturing_upgrade0_1_005()
	{
		// Keep the work center info, we'll put it into locations
		$GLOBALS['egw_setup']->db->select('perp_work_center',
			array(
				'work_center_id',
				'work_center_name',
				'location',
				'overhead_per_hour',
				'overhead_account',
				'account',
				'scanning'
			),
			array(),
			__LINE__, __FILE__
		);

		$work_centers = array();
		while($row = $GLOBALS['egw_setup']->db->row(true)) {
			$work_centers[] = $row;
		}
		$GLOBALS['egw_setup']->db->delete('perp_work_center',
			array('location IS NOT NULL'), __LINE__, __FILE__
		);

		$GLOBALS['egw_setup']->oProc->DropColumn('perp_work_center',array(
			'fd' => array(
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('location' => 'perp_location.location_id','overhead_account' => 'perp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array(array('location','work_center_name'))
		),'work_center_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_work_center',array(
			'fd' => array(
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('location' => 'perp_location.location_id','overhead_account' => 'perp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array(array('location','work_center_name'))
		),'work_center_name');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_work_center','location','location_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_work_center',array(
			'fd' => array(
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('location' => 'perp_location.location_id','overhead_account' => 'perp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array(array('location','work_center_name'))
		),'description');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_center','location_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_center',array(
			'fd' => array(
				'location_id' => array('type' => 'int','precision' => '4'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('location_id'),
			'fk' => array('location_id' => 'perp_location.location_id','overhead_account' => 'perp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));
		// Create locations for work centers
		foreach($work_centers as $work_center) {
			$GLOBALS['egw_setup']->db->insert('perp_location',
				array(
					'location_parent'	=>	$work_center['location'],
					'location_name'		=>	$work_center['work_center_name']
				),
				false,
				__LINE__, __FILE__, 'perp_inventory'
			);
			$location_id = $GLOBALS['egw_setup']->db->get_last_insert_id('perp_location', 'location_id');
			if(!$location_id) {
				$GLOBALS['egw_setup']->db->select('perp_location',
					array('location_id'),
					array('location_name'	=>	$work_center['work_center_name']),
					__LINE__, __FILE__, 
					false, '', 'perp_inventory'
				);
				$row = $GLOBALS['egw_setup']->db->row(true);
				$location_id = $row['location_id'];
			}
			if(!$location_id) {
				continue;
			}
			$GLOBALS['egw_setup']->db->insert('perp_work_center',
				array(
					'location_id'		=>	$location_id,
				) + $work_center,
				false,
				__LINE__, __FILE__, 'perp_manufacturing'
			);

			// Move work center bins into location stock
			$GLOBALS['egw_setup']->db->select('perp_work_center_bin',
				array(
					'stock_id',
					'quantity_on_hand',
					'capacity AS max_on_hand'
				),
				array(
					'work_center_id'	=>	$work_center['work_center_id']
				),
				__LINE__, __FILE__
			);
			$stock_list = array();
			while($row = $GLOBALS['egw_setup']->db->row(true)) {
				$stock_list[] = $row;
			}
			foreach($stock_list as $stock_item) {
				$GLOBALS['egw_setup']->db->insert('perp_location_stock',
					array(
						'location_id'	=>	$location_id,
					) + $stock_item,
					false, __LINE__, __FILE__
				);
			}
		}

		$GLOBALS['egw_setup']->oProc->DropTable('perp_work_center_bin');

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function perp_manufacturing_upgrade0_1_006()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('egw_wf_agent_perp_build',array(
			'fd' => array(
				'wf_agent_id' => array('type' => 'int','precision' => '4'),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('wf_agent_id'),
			'fk' => array('work_center_id' => 'perp_work_center.location_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function perp_manufacturing_upgrade0_1_007()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('egw_wf_agent_perp_build','wf_agent_id',array(
			'type' => 'auto',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function perp_manufacturing_upgrade0_1_008()
	{
		$GLOBALS['egw_setup']->oProc->DropTable('perp_stock_build_path');

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function perp_manufacturing_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('egw_wf_agent_perp_build','wf_agent_id',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('egw_wf_agent_perp_build','display_parts',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function perp_manufacturing_upgrade0_1_010()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_bill_of_material_detail','bill_of_material_detail_id',array(
			'type' => 'auto',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_bill_of_material_detail',array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'comment' => array('type' => 'varchar','precision' => '255'),
				'time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'bill_of_material_detail_id' => array('type' => 'auto','nullable' => False)
			),
			'pk' => array('bill_of_material_detail_id'),
			'fk' => array('bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id','component' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('bill_of_material_id','component','work_center'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function perp_manufacturing_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','component' => 'perp_stock.stock_id','work_center_id' => 'perp_work_center.work_center_id'),
			'ix' => array('component','work_center_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function perp_manufacturing_upgrade0_1_012()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_work_order_bill_of_material','bill_of_material_detail_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'bill_of_material_detail_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('work_order_id','detail_id','bill_of_material_detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','component' => 'perp_stock.stock_id','work_center_id' => 'perp_work_center.work_center_id','bill_of_material_detail_id' => 'perp_bill_of_material_detail.bill_of_material_detail_id'),
			'ix' => array('component','work_center_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function perp_manufacturing_upgrade0_1_013()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_bill_of_material','work_order_id',array(
			'type' => 'int',
			'precision' => '4'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_bill_of_material','detail_id',array(
			'type' => 'int',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function perp_manufacturing_upgrade0_1_014()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_bill_of_material','component',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'component' => array('type' => 'int','precision' => '4'),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'bill_of_material_detail_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('work_order_id','detail_id','component','bill_of_material_detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','component' => 'perp_stock.stock_id','work_center_id' => 'perp_work_center.work_center_id','bill_of_material_detail_id' => 'perp_bill_of_material_detail.bill_of_material_detail_id'),
			'ix' => array('work_center_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function perp_manufacturing_upgrade0_1_015()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_serial_setup',array(
			'fd' => array(
				'setup_id' => array('type' => 'auto','nullable' => False),
				'name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'pattern' => array('type' => 'varchar','precision' => '50','nullable' => False,'default' => '%1$05d')
			),
			'pk' => array('setup_id'),
			'fk' => array(),
			'ix' => array(),
			'uc' => array('name')
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function perp_manufacturing_upgrade0_1_016()
	{
		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function perp_manufacturing_upgrade0_1_017()
	{
		$GLOBALS['egw_setup']->oProc->DropTable('perp_work_order_bill_of_material');
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'bill_of_material_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('work_order_id','detail_id','bill_of_material_detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id'),
			'ix' => array(),
			'uc' => array()
		));

		$GLOBALS['egw_setup']->oProc->Query('INSERT INTO perp_work_order_bill_of_material (
				work_order_id, detail_id, bill_of_material_id
			) SELECT work_order_id, detail_id, bill_of_material_id FROM perp_work_order_detail');

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function perp_manufacturing_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_work_order_detail',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'option_search' => array('type' => 'text')
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id','bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id'),
			'ix' => array(),
			'uc' => array()
		),'bill_of_material_id');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_detail','work_order_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_detail','detail_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_detail',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'option_search' => array('type' => 'text')
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function perp_manufacturing_upgrade0_1_019()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_work_order_option','stock_id','component');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_work_order_option','category','option_bom_id');

		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_option','work_order_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_option','detail_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_option','build_option_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_option','component',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_option','option_bom_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'build_option_id' => array('type' => 'int','precision' => '4'),
				'component' => array('type' => 'int','precision' => '4'),
				'option_bom_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('work_order_id','detail_id','build_option_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_id' => 'perp_build_option.build_option_id','component' => 'perp_stock.stock_id','option_bom_id' => 'perp_work_order_bill_of_material.bill_of_material_id'),
			'ix' => array(),
			'uc' => array()
		));


		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.020';
	}


	$test[] = '0.1.020';
	function perp_manufacturing_upgrade0_1_020()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_work_order_option','work_center_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'build_option_id' => array('type' => 'int','precision' => '4'),
				'component' => array('type' => 'int','precision' => '4'),
				'option_bom_id' => array('type' => 'int','precision' => '4'),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','build_option_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_id' => 'perp_build_option.build_option_id','component' => 'perp_stock.stock_id','option_bom_id' => 'perp_work_order_bill_of_material.bill_of_material_id','work_center_id' => 'perp_work_center.location_id'),
			'ix' => array(),
			'uc' => array()
		));

		$GLOBALS['egw_setup']->oProc->Query('UPDATE perp_work_order_option SET option_bom_id = null');

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.021';
	}


	$test[] = '0.1.021';
	function perp_manufacturing_upgrade0_1_021()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_work_order_bom_change',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'component' => array('type' => 'int','precision' => '4'),
				'bill_of_material_detail_id' => array('type' => 'int','precision' => '4'),
				'delta_quantity' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','component','bill_of_material_detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','work_center_id' => 'perp_work_center.location_id','component' => 'perp_stock.stock_id','bill_of_material_detail_id' => 'perp_bill_of_material.bill_of_material_detail_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.022';
	}


	$test[] = '0.1.022';
	function perp_manufacturing_upgrade0_1_022()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_work_order_bill_of_material','quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'bill_of_material_id' => array('type' => 'int','precision' => '4'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('work_order_id','detail_id','bill_of_material_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.023';
	}


	$test[] = '0.1.023';
	function perp_manufacturing_upgrade0_1_023()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_work_order_option','option_category_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'build_option_id' => array('type' => 'int','precision' => '4'),
				'component' => array('type' => 'int','precision' => '4'),
				'option_bom_id' => array('type' => 'int','precision' => '4'),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'option_category_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','build_option_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_id' => 'perp_build_option.build_option_id','component' => 'perp_stock.stock_id','option_bom_id' => 'perp_work_order_bill_of_material.bill_of_material_id','work_center_id' => 'perp_work_center.location_id','option_category_id' => 'perp_build_option.build_option_category'),
			'ix' => array(),
			'uc' => array()
		));

		$GLOBALS['egw_setup']->oProc->Query('UPDATE perp_work_order_option SET option_category_id = (SELECT build_option_category FROM perp_build_option
		WHERE perp_work_order_option.build_option_id = perp_build_option.build_option_id)');

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.024';
	}


	$test[] = '0.1.024';
	function perp_manufacturing_upgrade0_1_024()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_work_order_option','option_category_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'build_option_id' => array('type' => 'int','precision' => '4'),
				'component' => array('type' => 'int','precision' => '4'),
				'option_bom_id' => array('type' => 'int','precision' => '4'),
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'option_category_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('work_order_id','detail_id','option_category_id'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_id' => 'perp_build_option.build_option_id','component' => 'perp_stock.stock_id','option_bom_id' => 'perp_work_order_bill_of_material.bill_of_material_id','work_center_id' => 'perp_work_center.location_id','option_category_id' => 'perp_build_option.build_option_category'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.025';
	}


	$test[] = '0.1.025';
	function perp_manufacturing_upgrade0_1_025()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_allowed_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'value' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'effective_from' => array('type' => 'timestamp')
			),
			'pk' => array('build_option_id','stock_id','effective_from'),
			'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_stock.stock_id','component' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('component','work_center'),
			'uc' => array()
		));

		$GLOBALS['egw_setup']->oProc->Query('UPDATE perp_allowed_build_option SET effective_from = \'' . $GLOBALS['egw_setup']->db->to_timestamp(time()) . '\'');

		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.1.026';
	}

	$test[] = '0.1.026';
	function perp_manufacturing_upgrade0_1_026()
	{
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_work_order',
				'perp_work_order_detail',
				'perp_work_order_option',
				'perp_stock_assembly_serial',
				'perp_serial_setup',
				'egw_wf_agent_perp_build',
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_manufacturing', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2';
	}


function perp_manufacturing_upgrade0_2()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_work_center_location',array(
		'fd' => array(
			'work_center_id' => array('type' => 'int','precision' => '4'),
			'location_id' => array('type' => 'int','precision' => '4'),
			'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'overhead_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'user_account' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('work_center_id','location_id'),
		'fk' => array('work_center_id' => 'perp_work_center.work_center_id','location_id' => 'perp_location.location_id','user_account' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.001';
}


function perp_manufacturing_upgrade0_2_001()
{
	$work_centers = array();
	foreach($GLOBALS['egw_setup']->oProc->query('SELECT * FROM perp_work_center JOIN perp_location ON perp_location.location_id = perp_work_center.location_id') as $row ){
		$work_centers[] = $row;
	}

	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_center',array(
		'fd' => array(
			'work_center_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '30','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255'),
			'default_overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'default_overhead_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'default_user_account' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('work_center_id'),
		'fk' => array('default_overhead_account' => 'perp_account.account_id','default_user_account' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));
	$GLOBALS['egw_setup']->oProc->query('DELETE FROM perp_work_center');
	foreach($work_centers as $work_center) {
		$sql = 'INSERT INTO perp_work_center
			(name, description, default_overhead_per_hour, default_overhead_account, default_user_account)
			VALUES (\'' . 
				$work_center['location_name'] . '\',\'' . 
				$work_center['location_name'] . '\',' .
				$work_center['overhead_per_hour'] . ',\''.
				$work_center['overhead_account'] . '\','.
				$work_center['account'] .
			')';
		$GLOBALS['egw_setup']->oProc->query($sql);
		$work_center_id = $GLOBALS['egw_setup']->oProc->m_odb->get_last_insert_id('perp_work_center', 'work_center_id');
		$GLOBALS['egw_setup']->oProc->query('INSERT INTO perp_work_center_location 
			(work_center_id, location_id, overhead_per_hour, overhead_account, user_account)
			VALUES (' . 
				$work_center_id . ',' .
				$work_center['location_id'] . ',' .
				$work_center['overhead_per_hour'] . ',\''.
				$work_center['overhead_account'] . '\','.
				$work_center['account'] .
			')'
		);
	}

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.002';
}


function perp_manufacturing_upgrade0_2_002()
{
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_center',array(
		'fd' => array(
			'work_center_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'default_overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'default_overhead_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'default_user_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '30','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('work_center_id'),
		'fk' => array('default_overhead_account' => 'perp_account.account_id','default_user_account' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array('name')
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.003';
}


function perp_manufacturing_upgrade0_2_003()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_work_order_retrofit',array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4'),
			'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'reference' => array('type' => 'varchar','precision' => '255'),
			'build_option_category_id' => array('type' => 'int','precision' => '4'),
			'build_option_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id','account_id' => 'egw_accounts.account_id','build_option_category_id' => 'perp_build_option_category.build_option_category_id','build_option_id' => 'perp_build_option.build_option_id'),
		'ix' => array('build_option_category_id'),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.004';
}

function perp_manufacturing_upgrade0_2_004() {
	$application = 'perp_manufacturing';
	$location = 'retrofit';
	$rights = 7;
	$admin = -2;

	$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', 0,$rights)");

	// Give admin rights to everything
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', $admin,$rights)");

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.005';
}


function perp_manufacturing_upgrade0_2_005()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_history','link_app',array(
		'type' => 'varchar',
		'precision' => '25'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_history','link_id',array(
		'type' => 'varchar',
		'precision' => '50'
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.006';
}


function perp_manufacturing_upgrade0_2_006()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_build_option_category','ships_separate',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => 'false'
	));*/
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_build_option_category','can_retrofit',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => 'false'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_category',array(
		'fd' => array(
			'build_option_category_id' => array('type' => 'auto','nullable' => False),
			'build_option_category_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'stock_category' => array('type' => 'int','precision' => '4','nullable' => False),
			'required' => array('type' => 'bool','nullable' => False,'default' => '1'),
			'ships_separate' => array('type' => 'bool','nullable' => False,'default' => '0'),
			'can_retrofit' => array('type' => 'bool','nullable' => False,'default' => '0')
		),
		'pk' => array('build_option_category_id'),
		'fk' => array('stock_category' => 'perp_stock_category.stock_category_id'),
		'ix' => array('build_option_category_id','stock_category','can_retrofit'),
		'uc' => array('build_option_category_id','build_option_category_name')
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.007';
}


function perp_manufacturing_upgrade0_2_007()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_work_order_option_history',array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'build_option_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'old_option' => array('type' => 'int','precision' => '4','nullable' => False),
			'new_option' => array('type' => 'int','precision' => '4','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'changed_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'history_id' => array('type' => 'auto','nullable' => False)
		),
		'pk' => array('history_id'),
		'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_category_id' => 'perp_build_option_category.build_option_category_id','old_option' => 'perp_build_option.build_option_id','new_option' => 'perp_build_option.build_option_id','changed_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.008';
}


function perp_manufacturing_upgrade0_2_008()
{
	// Remove temporary work_order_history table added by perp_inventory
	$definition = $GLOBALS['egw_setup']->oProc->GetTableDefinition('perp_work_order_history');
	if(!$definition) {
		// Temp able hasn't been created yet
		return false;
	} else {
		$GLOBALS['egw_setup']->oProc->DropTable('perp_work_order_history');
		$GLOBALS['egw_setup']->oProc->query("delete from egw_acl where acl_appname = 'perp_manufacturing' and acl_location = 'stock_history'");
		return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.009';
	}
}

// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_manufacturing');

function perp_manufacturing_upgrade0_2_009()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_workflow_stock',array(
		'fd' => array(
			'workflow_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'last_change' => array('type' => 'timestamp')
		),
		'pk' => array('workflow_id','stock_id'),
		'fk' => array('workflow_id' => 'egw_wf_processes.wf_p_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.010';
}


function perp_manufacturing_upgrade0_2_010()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_assembly_serial','quantity',array(
		'type' => 'decimal',
		'precision' => '20',
		'scale' => '3',
		'nullable' => False,
		'default' => '1'
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.011';
}


function perp_manufacturing_upgrade0_2_011()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_build_option_exclusion',array(
		'fd' => array(
			'option_1' => array('type' => 'int','precision' => '4'),
			'option_2' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('option_1','option_2'),
		'fk' => array('option_1' => 'perp_build_option.build_option_id','option_2' => 'perp_build_option.build_option_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_manufacturing']['currentver'] = '0.2.012';
}

