<?php

	/**
	*	Logic layer object for dealing with backordered goods
	*/

	require_once('class.so_perp_backorder.inc.php');

	class bo_perp_backorder {

		protected $so_perp_backorder;

		public function __construct() {
			$this->so_perp_backorder = new so_perp_backorder();
		}

		/**
		*	Get a list of goods that have been ordered, but we don't
		*	have the stock on hand to ship.
		*
		*	@nextmatch
		*/
		public function get_backorder_list(&$query, &$rows = array(), &$readonly = array()) {

			if($query['filter']) {
				$query['location_id'] = $query['filter'];
			}
			if(!$query['order']) {
				$query['order'] = 'requested_delivery_date';
			}

			$rows = $this->so_perp_backorder->get_backorder_list( $query);
			
			return $query['count'];
		}
		
	}
?>
