<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_orders/inc/class.SalesOrder.inc.php');

	$GLOBALS['egw']->translation->add_app('perp_orders');

	$span = array(
		'1'	=>	'Today',
		'7'	=>	'This week',
		'mine'	=>	'For my stuff',
	);

	$app_id = $GLOBALS['egw']->applications->name2id('perp_orders');
	$GLOBALS['portal_order'][] = $app_id;
	$old_app = $GLOBALS['egw_info']['flags']['currentapp'];
	$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_orders';
	$portalbox =& CreateObject('phpgwapi.listbox', array(
		'title'		=>	lang('perp_orders'),
		'primary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'secondary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'tertiary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'width'		=>	'100%',
		'outerborderwidth' => '0',
		'header_background_image' => $GLOBALS['egw']->common->image('phpgwapi/templates/default','bg_filler')
	));

	$portalbox->data = $data;
	foreach(array('up','down','close','question','edit') as $key) {
		$portalbox->set_controls($key,Array('url' => '/set_box.php', 'app' => $app_id));
	}
	$html = '<table width="100%"><tbody><tr style="vertical-align: top;">';

	if (($showevents = (int) $GLOBALS['egw_info']['user']['preferences']['perp_orders']['homepage_display_sales_order_approval']) > 0) {
		$orders = array();
		$readonlys = array();
		$boso = CreateObject('perp_orders.bo_perp_sales_order');
		$boso->get_order_list(array('filter' => 'request', 'template' => false), $orders, $readonlys['nextmatch']['rows']);

		// Filter only the ones current user is approver for
		foreach ($orders as $key => $row) {
			if(is_integer($key) && is_array($row)) {
				$order = new SalesOrder( $row['order_id']);
				if($order->is_admin($GLOBALS['egw_info']['user']['account_id']) !== True) {
					unset($data[$key]);
				}
			}
		}

		if(count($orders) > 1) {
			array_unshift($orders, false);
			$data['nextmatch']['rows'] = $orders;
			$html .= '</tr><tr><td colspan="2">';
			$template = CreateObject('etemplate.etemplate');
			$template->read('perp_orders.home.sales_order_list');
			$html .= $template->exec('perp_orders.ui_perp_sales_order.order_list', $data, $select_box_options, $readonlys, null, -1);
			$html .= '</td>';
		}
	}

	$html .= '</tr></tbody></table>';

	if (!file_exists(EGW_SERVER_ROOT.($css_file ='/perp_orders/templates/'.$GLOBALS['egw_info']['user']['preferences']['common']['template_set'].'/app.css'))) {
		$css_file = '/perp_orders/templates/default/app.css';
	}
	$GLOBALS['egw_info']['flags']['currentapp'] = $old_app;
        echo '
<style type="text/css">
<!--
        @import url('.$GLOBALS['egw_info']['server']['webserver_url'].$css_file.');
-->
</style>';
	echo $portalbox->draw($html);
	
?>
