<?php
/* This is one part that, due to API constraints, still needs its own hook file */

	$config = config::read('perp_orders');

	$temp = $GLOBALS['egw']->acl->get_ids_for_location('order', EGW_ACL_CUSTOM_1, 'perp_orders');
	if($temp) {
		foreach($temp as $id) {
			if($id) {
				$expand = $GLOBALS['egw']->accounts->member($id);
				if(is_array($expand)) {
					foreach($expand as $acct) {
						$temp[] = $acct['account_id'];
					}
				}
			}
		}
		foreach($temp as $id) {
			$so_admins[$id] = $GLOBALS['egw']->accounts->id2name($id);
		}

		$settings = array();
		if($config['requires_approval']) {
			$settings['supervisors'] = array(
				'type'	=>	'select',
				'label'	=>	'Who approves your sales orders',
				'name'	=>	'supervisors',
				'values'	=>	$so_admins,
				'help'	=>	'',
			);
		}
	}

	// We NEED a preference called homepage_display to get the API to display our app on the homepage
	$settings['homepage_display'] = array(
		'type'	=>	'check',
		'label'	=>	'Show order information on home page',
		'name'	=>	'homepage_display',
	);

	if(is_array($so_admins) && in_array($GLOBALS['egw_info']['user']['account_id'], array_keys($so_admins)) && $config['requires_approval']) {
		$settings['homepage_display_sales_order_approval'] = array(
			'type'	=>	'select',
			'label'	=>	'Show Sales Orders for you to approve on home page',
			'name'	=>	'homepage_display_sales_order_approval',
			'values'	=>	array('0' => 'No', '2' => 'Yes'),
		);
	}

	// For items with build options, show the option tree on the price list
	$settings['hide_options'] = array(
		'type'	=>	'select',
		'label'	=>	'Hide build options on price lists',
		'name'	=>	'hide_options',
		'values'	=>	array('0' => 'No', '2' => 'Yes'),
		'help'	=>	'When you view or edit a price list that has items with build options, should all the build options be displayed?  You can turn them back on when you need to see them.'
	);

	$GLOBALS['settings'] = $settings;
	unset($temp);
	unset($so_admins);

	return $settings;
?>
