<?php
	$locations = array(
		'acl'		=>	5, 
		'order'		=>	79,
		'sales_category'=>	15,
		'sales_area'	=>	15,
		'sales_type'	=>	15,
		'price_list'	=>	15,
		'discount_matrix'	=>	15,
		'calculation'	=>	15,
	);

	// We assume that Admins group is group #2
	$admin = -2;
	$app_name = 'perp_orders';
	foreach ($locations as $location => $rights) {
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$app_name', '$location', 0,$rights)");

		// Give admin rights to everything
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$app_name', '$location', $admin,$rights)");
	}

	// Give admin run rights
	$GLOBALS['egw_setup']->add_acl($application, 'run', $admin);
	
	// Add an infolog type for price overrides
	// We have to do it directly, because infolog can't use the regular db object.
	$config =& CreateObject('phpgwapi.config', 'infolog');
	$config->read_repository();
	if(is_array($config->config_data['types'])) {
		$config->config_data['types']['price_override'] = 'price override';
		$config->config_data['status']['defaults']['price_override'] = 'ongoing';
		$config->config_data['status']['price_override']['ongoing'] = 'ongoing';
		$config->config_data['status']['price_override']['done'] = 'done';
		$config->save_repository();
	}

	// Default infolog type to price override
	config::save_value('price_override_type', 'price_override', $app_name);

	if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
		// These tables need to be InnoDB
		$transaction_tables = array(
			'perp_sales_order',
			'perp_sales_order_detail',
			'perp_sales_order_work_order'
		);
		$so_perp_api = CreateObject('perp_api.so_perp_api');
		$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, $transaction_tables);
	}

	// Put in some sample price adjustment calculations
	// 10% increase
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_price_calculation (name, calculation, variable_prompt) 
		VALUES ('10% increase', '$current_price * 1.1', null)");
	
	// Prompted increase
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_price_calculation (name, calculation, variable_prompt) 
		VALUES ('Price increase', 'max(1, $current_price) * (($custom > 1 ? ($custom / 100) : $custom) +1)', 'Percentage price increase (no % sign):)')");

	// Stepped Pricing From Cost
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_price_calculation (name, calculation, variable_prompt) 
		VALUES ('Stepped pricing from cost', '// This calculation will not work for items you do not have on hand because the FIFO cost is 0
		( $current_price >= 100 ?
		$current_fifo * 1.5 :
		$current_fifo *2
		)', null)");

?>
