<?php
	/**************************************************************************\
	* pERP - perp_orders                                                   	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_orders']['name']      = 'perp_orders';
	$setup_info['perp_orders']['version']   = '0.2.014';
	$setup_info['perp_orders']['app_order'] = 16;
	$setup_info['perp_orders']['enable']    = 1;

	$setup_info['perp_orders']['author'] = 'Nathan Gray';
 	$setup_info['perp_orders']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_orders']['license']  = 'GPL';
	$setup_info['perp_orders']['description'] = 'Accounts Receivalbe module for pERP';
	$setup_info['perp_orders']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_orders']['hooks']['preferences'] = 'perp_orders.hook_perp_orders.preference_menu';
	$setup_info['perp_orders']['hooks'][] = 'settings';
	$setup_info['perp_orders']['hooks']['admin'] = 'perp_orders.hook_perp_orders.admin_hook';
	$setup_info['perp_orders']['hooks']['search_link'] = 'perp_orders.hook_perp_orders.search_link';
	$setup_info['perp_orders']['hooks']['sidebox_menu'] = 'perp_orders.hook_perp_orders.sidebox';
	$setup_info['perp_orders']['hooks'][] = 'home';//] = 'perp_orders.hook_perp_orders.home';
	$setup_info['perp_orders']['hooks']['perp_ar:invoicable'] = 'perp_orders.hook_perp_orders.invoicable';
	

	/* Dependencies for this app to work */
	$setup_info['perp_orders']['depends'][] = array(
		 'appname' => 'perp_ledger',
		 'versions' => Array('0.1', '0.2')
	);
	$setup_info['perp_orders']['depends'][] = array(
		 'appname' => 'perp_inventory',
		 'versions' => Array('0.2')
	);
	$setup_info['perp_orders']['depends'][] = array(
		 'appname' => 'perp_ar',
		 'versions' => Array('0.1', '0.2')
	);
	$setup_info['perp_orders']['depends'][] = array(
		 'appname' => 'infolog',
		 'versions' => Array('1.4', '1.5', '1.6')
	);

	$setup_info['perp_orders']['tables'] = array('perp_sales_category','perp_stock_sales_category','perp_price_list','perp_price','perp_sales_area','perp_build_option_price','perp_sales_order','perp_sales_order_detail','perp_sales_type','perp_sales_order_work_order','perp_stock_kit_price','perp_price_calculation');
















