<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_setup_wizard/inc/steps/class.perp_setup_step.inc.php');

	class _2_6_bank_accounts extends perp_setup_step {
		
		protected $app = 'perp_ledger';
		
		//this array is the set of acl check it must pass to alloww the user to complete
		protected $acls = array('bank_account');
		
		//the protected variable $dependencies is the set of steps that this step needs completed to be able to work
		//protected $dependencies = array('step_one');
		
		public function _2_6_bank_accounts() {
			parent::__construct();
		}
		
		/**
		*  get_step_data function
		*  
		* @param content the variables passed in from the wizard
		* @param data passed by reference from the wizard to pass in exec template call
		* @param select_box_options passed by reference from the wizard to pass in exec template call
		* @param readonly passed by reference from the wizard to pass in exec template call
		* @param preserve passed by reference from the wizard to pass in exec template call
		*/
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
			
			$data['step_name'] = $this->step_name;			
			parent::get_step_data($content, $data, $step_data, $select_box_options, $readonly, $preserve);
			
			//step data
			$step_data['decription_body'] = lang('_2_6_bank_accounts_description_body').'<br/><br/>'.'<input id="exec[button]" type="submit" onclick="egw_openWindowCentered2(\''.$GLOBALS['egw']->link('/index.php', array('menuaction' => 'addressbook.addressbook_ui.edit')).'\', \'_blank\', \'850\', \'440\', \'yes\'); return false;" value="Click here to add bank address" name="exec[button]"/>';
			$step_data['link_to_step'] = 'perp_ledger.hook_perp_ledger.bank_account';
			$data['step_data'] = $step_data;
			//$GLOBALS['egw']->link('/index.php', array('menuaction' => 'addressbook.addressbook_ui.edit'));
			
		}
		
		/**
		*  get_permission function
		*  @brief this function is ran from wizards build_permissions function
		*  it calls the parent generic_step get_permission
		*/
		public function get_permission(){
			return parent::get_permission();		
		}
		
		/**
		*  complete_step function
		*  @brief this function is ran when it is the current working step in the session
		*  it determines if the step is complete from any location in eGroupware
		*  it is called from hook_topmenu_info
		*  @param content the variables passed in from the wizard
		*/
		public function complete_step($content){
			if(array_pop(split("[.]",$_SERVER["REQUEST_URI"])) == 'bank_account'){
				$data = $content;
				$data['step_name']	= $this->step_name;
				parent::complete_step($data);
			}		
		}
		
	}
?>