<?php
	$locations = array(
		'acl'		=>	5, 
		'timestamp'	=>	15,		// For a punchclock, let wage slaves (or TimeClock devices) clock in and out
		'people_in_building'	=>	1,		// How many people are still clocked in
		'config'	=>	64,			// Allow configuration of Timeclock machine
		'reboot'	=>	64,			// Allow rebooting of Timeclock machine
	);

	$application = 'perp_timeclock';
	// We assume that Admins group is group #2
	$admin = -2;
	foreach ($locations as $location => $rights) {
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', 0,$rights)");

		// Give admin rights to everything
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$application', '$location', $admin,$rights)");
	}


	$timeclock_permissions = array(
		'perp_timeclock'        =>      array(
			'run'			=>	1,
			'config'                =>      64,
			'reboot'                =>      64,
			'timestamp'             =>      2
		),
		'perp_payroll'          =>      array(
		),
		'perp_human_resources'  =>      array(
			'run'			=>	1,
			'staff_authentication'  =>      3
		),
	);

	// Create a group for timeclock type devices for easy admin
	$group_id = (int)$GLOBALS['egw_setup']->add_account('TimeClocks', 'TimeClocks', 'Group', False, False);

	if($group_id) {
		echo lang('Added "TimeClocks" group to give timeclocks access') . '<br />';

		// Set timeclock permissions
		foreach($timeclock_permissions as $appname => $location_list) {
			foreach($location_list as $location => $permission) {
				$GLOBALS['egw_setup']->add_acl($appname, $location, $group_id, $permission);
			}
		}
			
	
		// New user for the timeclock
		$account_id = (int)$GLOBALS['egw_setup']->add_account('timeclock1','Time','Clock 1','','TimeClocks',True,'');
	}

	// Add a custom field to TimeSheet, staff_id
	$custom = config::get_customfields('timesheet');
	$custom['staff_id'] = array(
	    'name'	=>	'staff_id',
	    'label'	=>	lang('Employee'),
	    'type'	=>	'perp_human_resources',
	    'order'	=>	10
	);
	config::save_value('customfields', $custom, 'timesheet');
?>
