<?php

	/**
	*	Record the serial number of an item on a RMALine
	*	
	*	Extending class used so we can tell it apart from other details easily.
	*/
	
	require_once( EGW_INCLUDE_ROOT . '/perp_api/inc/class.OrderLineDetail.inc.php');

	class SerialNumberDetail extends OrderLineDetail {

		public function &get_action() {
			$action_details =& $this->get_order_line()->get_detail('SN-' . $this->detail_number);
			return current($action_details);
		}

		public function toArray() {
			$array = parent::toArray();
			if($action_detail =& $this->get_action()) {
				$array['action'] = $action_detail->get_value();
			}
			return $array;
		}
	}
?>
