/**
 * Javascript for RMAs
 */

function rma_setup() {
	var button = 'exec[new][serial_number_button]';
	document.getElementById(button).parentNode.style.visibility = 'collapse';
}

/* Called (as a callback) when the user selects an item from the item
*  List.  Displays the serial button.
*/
function select_item(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}

	xajax_doXMLHTTP( ajax_perp_order + ".change_stock_code", target.value);
}


/**
*	Enter serial numbers for parts
*/
function get_serials(e, url) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	} else if (e.id) {
		var target = e;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parent;
	}

	var base_id = target.id.replace(/\[serial_number_button\]/gi, '');

//	var claim_issue_id = document.getElementById('exec[claim_issue_id]');
	var stock_id = document.getElementById(base_id + '[stock_id][value]');
	if(!stock_id) {
		// Editing an existing row, need to change things
		base_id = base_id.replace(/\[details\]\[SerialNumberDetail\]/gi, '');
		stock_id = document.getElementById(base_id + '[stock_id]');
	}
	var quantity = document.getElementById(base_id + '[quantity_ordered]');
	var serials = document.getElementById(base_id + '[serial_numbers]');

//	if(claim_issue_id) {
//		url += '&claim_issue_id=' + claim_issue_id.value;
//	}
	if(stock_id) {
		url += '&stock_id=' + stock_id.value;
	}
	if(quantity) {
		url += '&quantity=' + quantity.value;
	}
	if(base_id) {
		url += '&base_id=' + base_id;
	}
	if(serials) {
		url += '&serials=' + serials.value;
	}

	if(quantity && quantity.value > 0) {
		window.open(url,'_blank','dependent=yes,width=600,height=450,scrollbars=yes,status=yes');
	} else {
		alert('Quantity is 0');
	}
	return false;
}
