<?php
	// Set up ACLs
	$locations = array(
		'acl'		=>	5, 
		'claim'		=>	7,
		'rma'		=>	15,
		'issue'		=>	15,
		'stock'		=>	5,
		'supplier'	=>	5,
		'client'	=>	5,
		'registration'	=>	79
	);
	// We assume that Admins group is group #2
	$admin = -2;
	$app_name = 'perp_warranty';

	foreach ($locations as $location => $access) {
		$sql = "INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) 
			VALUES ('$app_name', '$location', 0,$access)";
		$GLOBALS['egw_setup']->oProc->query($sql);

		// Give admin rights to everything
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('$app_name', '$location', $admin, $access)");
	}

	// Give admin run rights
	$GLOBALS['egw_setup']->add_acl($app_name, 'run', $admin);
	

	// Default Data

	// Create some standard issues
	$sql = "INSERT INTO perp_warranty_issue (issue_id, name, description, coverage)
		VALUES (1, '" . 'Other' . "', '" . 'An unknown issue' . "', 1)";
	$GLOBALS['egw_setup']->oProc->query($sql);

	$sql = "INSERT INTO perp_warranty_issue (issue_id, name, description, coverage)
		VALUES (2, '" . 'Material Failure' . "', '" . 'A failure in the materials that the item is made from' . "', 1)";
	$GLOBALS['egw_setup']->oProc->query($sql);
	
?>
