<?php
	/**************************************************************************\
	* pERP - perp_warranty                                                 	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_warranty']['name']      = 'perp_warranty';
	$setup_info['perp_warranty']['version']   = '0.1.012';
	$setup_info['perp_warranty']['app_order'] = 17;
	$setup_info['perp_warranty']['enable']    = 1;

	$setup_info['perp_warranty']['author'] = 'Nathan Gray';
 	$setup_info['perp_warranty']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_warranty']['license']  = 'GPL';
	$setup_info['perp_warranty']['description'] = 'Warranty tracking for pERP';
	$setup_info['perp_warranty']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_warranty']['hooks']['preferences'] = 'perp_warranty.hook_perp_warranty.preference_menu';
	$setup_info['perp_warranty']['hooks'][] = 'settings';
	$setup_info['perp_warranty']['hooks']['admin'] = 'perp_warranty.hook_perp_warranty.admin_hook';
	$setup_info['perp_warranty']['hooks']['search_link'] = 'perp_warranty.hook_perp_warranty.search_link';
	$setup_info['perp_warranty']['hooks']['sidebox_menu'] = 'perp_warranty.hook_perp_warranty.sidebox';
	$setup_info['perp_warranty']['hooks'][] = 'home';//] = 'perp_warranty.hook_perp_warranty.home';
	$setup_info['perp_warranty']['hooks']['perp_ar:invoicable'] = 'perp_warranty.hook_perp_warranty.invoicable';
	

	/* Dependencies for this app to work */
	$setup_info['perp_warranty']['depends'][] = array(
		 'appname' => 'perp_api',
		 'versions' => Array('0.2', '0.3')
	);
	$setup_info['perp_warranty']['depends'][] = array(
		 'appname' => 'perp_inventory',
		 'versions' => Array('0.2')
	);
	$setup_info['perp_warranty']['depends'][] = array(
		 'appname' => 'perp_ar',
		 'versions' => Array('0.2')
	);
	$setup_info['perp_warranty']['depends'][] = array(
		 'appname' => 'perp_ap',
		 'versions' => Array('0.2')
	);
	$setup_info['perp_warranty']['depends'][] = array(
		 'appname' => 'tracker',
		 'versions' => Array('1.6', '1.7')
	);

	$setup_info['perp_warranty']['tables'] = array('perp_warranty_issue','perp_warranty_issue_stock_cat','perp_warranty_replacement_parts','perp_warranty_issue_exception','perp_warranty_client_category','perp_client_warranty_category','perp_client_warranty_address','perp_stock_warranty','perp_warranty_registration','perp_rma','perp_rma_line','perp_rma_serial_number','perp_warranty_claim','perp_warranty_claim_issue','perp_warranty_claim_component','perp_warranty_claim_replacement','perp_warranty_claim_serial','perp_warranty_credit');










