#! /bin/sh

##
# Install script for pERP 
#
# Should get everything in the right places.
##

ver=0.3

# Check to see if this is SVN, or a packaged release
INSTALL="PACKAGE"
if [ -e "./.svn" ]; then
	INSTALL=SVN
	ver=SVN
fi



echo "         pERP Installation "
echo "          ($ver release)  "
echo

echo "Enter your eGroupWare directory:"
read EGW_DIR

echo "Installing pERP into $EGW_DIR..."
cp -ar perp_* $EGW_DIR

echo "Adding eGroupWare extensions"
echo

# Wizard base application
echo "Wizard base application..."

if [ $INSTALL = "SVN" ]; then
	if [ ! -L "$EGW_DIR"/wizard ]; then
		ln -s ./egroupware-addons/wizard "$EGW_DIR"/
	fi
	mv ./egroupware-addons/wizard.scrolling_sidebox_patch.txt "$EGW_DIR"/
else 
	echo "Package"
	mv ./egroupware-addons/wizard "$EGW_DIR"/
	mv ./egroupware-addons/wizard.scrolling_sidebox_patch.txt "$EGW_DIR"/
fi

if [ -f "$EGW_DIR"/wizard.scrolling_sidebox_patch.txt ]; then
	cd $EGW_DIR
	patch -p1 < "$EGW_DIR"/wizard.scrolling_sidebox_patch.txt
	cd -
	rm -rf "$EGW_DIR"/wizard.scrolling_sidebox_patch.txt
fi

echo "Wizard Scrolling Sidebox Patch has been applied."

echo "Done."
echo "Point your web browser to $EGW_DIR/setup to finish installing pERP into eGroupWare"
