// Additional javascript needed for PurchaseOrders.
//

function purchase_order_edit_setup() {

	// Set event handlers on unit of measure selectbox
	var new_uom = document.getElementById('exec[new][unit_of_measure]');
	if(new_uom && new_uom.addEventListener) {
		new_uom.addEventListener('change', change_unit_of_measure, true);
	} else if (new_uom) {
		new_uom.onchange = change_unit_of_measure;
	}
}

/**
 * Change handler for when user changes the unit of measure for a new item
 * to be added.  We change the unit price based on the new unit of measure.
 */
function change_unit_of_measure() {

	var new_uom = document.getElementById('exec[new][unit_of_measure]');
	var item = document.getElementById('exec[new][supplier_stock_code][search]');

	xajax_doXMLHTTP( ajax_perp_order + ".change_unit_of_measure", supplier_id, item.value, new_uom.value);
}
