<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


	$phpgw_baseline = array(
		'perp_supplier' => array(
			'fd' => array(
				'supplier_id' => array('type' => 'varchar','precision' => '10','nullable' => False),
				'supplier_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'supplier_address' => array('type' => 'int','precision' => '4'),
				'supplier_currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'supplier_since' => array('type' => 'date','nullable' => False),
				'payment_terms' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'bank_account' => array('type' => 'varchar','precision' => '30'),
				'bank_reference' => array('type' => 'varchar','precision' => '12'),
				'bank_particulars' => array('type' => 'varchar','precision' => '12'),
				'remittance' => array('type' => 'int','precision' => '4'),
				'tax_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('supplier_id'),
			'fk' => array('supplier_address' => 'perp_address.address_id','supplier_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id','tax_group' => 'erp_tax_group.tax_group_id'),
			'ix' => array('supplier_id'),
			'uc' => array('supplier_id','supplier_name')
		)
	);
