<?php

		 
	$cur_formats = array(
		'std'			=>	'Standard',	
		
		'2P'			=>	'1200,03',
		'2P,TP'			=>	'1.200,03',
		'2P,R'			=>	'-1200,03 [red]',
		'2P,TP,R'		=>	'-1.200,03 [red]',

		'3P'			=>	'1200,030',
		'3P,TP'			=>	'1.200,030',
		'3P,R'			=>	'-1200,030 [red]',
		'3P,TP,R'		=>	'-1.200,030 [red]',

		'2P,CBEF'		=>	'[CUR]1200,03',
		'2P,TP,CBEF'	=>	'[CUR]1.200,03',
		'2P,R,CBEF'		=>	'[CUR]-1200,03 [red]',
		'2P,TP,R,CBEF'	=>	'[CUR]-1.200,03 [red]',

		'3P,CBEF'		=>	'[CUR]1200,030',
		'3P,TP,CBEF'	=>	'[CUR]1.200,030',
		'3P,R,CBEF'		=>	'[CUR]-1200,030 [red]',
		'3P,TP,R,CBEF'	=>	'[CUR]-1.200,030 [red]',

		'2P,CAFT'		=>	'1200,03 [CUR]',
		'2P,TP,CAFT'	=>	'1.200,03 [CUR]',
		'2P,R,CAFT'		=>	'-1200,03 [CUR] [red]',
		'2P,TP,R,CAFT'	=>	'-1.200,03 [CUR] [red]',

		'3P,CAFT'		=>	'1200,030 [CUR]',
		'3P,TP,CAFT'	=>	'1.200,030 [CUR]',
		'3P,R,CAFT'		=>	'-1200,030 [CUR] [red]',
		'3P,TP,R,CAFT'	=>	'-1.200,030 [CUR] [red]',
		
		'2P,CP'			=>	'1200.03',
		'2P,TC,CP'		=>	'1,200.03',
		'2P,TC,CP,CAFT'		=>	'1,200.03 [CUR]',
		'2P,TC,CP,R'		=>	'-1,200.03 [red]',
		'2P,TC,CP,R,CAFT'	=>	'-1,200.03 [CUR] [red]',

		'3P,TC'		=>	'1200.030',
		'3P,TC,CP,CAFT'	=>	'1,200.030 [CUR]',
		'3P,TC,CP,R,'	=>	'-1,200.030 [red]',
		'3P,TC,CP,R,CAFT'	=>	'-1,200.030 [CUR] [red]',		
	);	
	
	$cur_list = ExecMethod('perp_api.so_perp_api.get_currencies');
	
	$table_pc = 'perp_currency';
	
	$settings['currency_formats'] = array(
		'type'	=>	'subsection',
		'name'	=>	'currency_formats_label',
		'title'	=>	'Currency formats'
	);

	foreach($cur_list as $cur_el) {		
		$settings[$table_pc.$cur_el['currency_id']] = array(
			'type'	=>	'select',
			'label'	=>	$cur_el['currency_id'].'. '.$cur_el['currency_name'],
			'name'	=>	$table_pc.'_'.$cur_el['currency_id'],
			'values'=>	$cur_formats,
			'help'	=>	'',
		);
	}
	
	$settings['report_output_format'] = array(
		'type'	=>	'select',
		'label'	=>	'Report output format',
		'name'	=>	'report_output_format',
		'values'	=>	ExecMethod('perp_api.bo_perp_report.get_supported_formats'),
		'help'	=>	'File format to use for report files.',
	);
	$GLOBALS['settings'] = $settings;

	return $settings;
?>
