<?php
	/**************************************************************************\
	* pERP - perp_api                                                          *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_api']['name']      = 'perp_api';
	$setup_info['perp_api']['version']   = '0.2.006';
	$setup_info['perp_api']['app_order'] = 1;
	$setup_info['perp_api']['enable']    = 2;

	$setup_info['perp_api']['author'] = 'Nathan Gray';
 	$setup_info['perp_api']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_api']['license']  = 'GPL';
	$setup_info['perp_api']['description'] = 'ERP base stuff, stuff needed by other perp apps.  This supplies the ACL and Config frameworks, as well as tables common to all applications';
	$setup_info['perp_api']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_api']['hooks'][] = 'settings';
	$setup_info['perp_api']['hooks']['preferences'] = 'perp_api.hook_perp_api.preference_menu';
	$setup_info['perp_api']['hooks']['admin'] = 'perp_api.hook_perp_api.admin_hook';

	/* Dependencies for this app to work */
	$setup_info['perp_api']['depends'][] = array(
		 'appname' => 'phpgwapi',
		 'versions' => Array('1.5', '1.6', '1.7')
	);
	$setup_info['perp_api']['depends'][] = array(
		 'appname' => 'etemplate',
		 'versions' => Array('1.5', '1.6', '1.7')
	);

	$setup_info['perp_api']['tables'] = array('perp_currency','perp_unit_of_measure','perp_tax_authority','perp_tax_group','perp_tax_category','perp_tax_location','perp_tax_group_tax','perp_tax_auth_rate','perp_payment_term','perp_payment_method','perp_shipper','perp_shipper_cost','perp_order','perp_order_line','perp_invoice','perp_invoice_line','perp_shipment','perp_shipment_line','perp_order_detail','perp_shipment_detail');





