<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.33 2005/12/19 04:27:19 ralfbecker Exp $ */

// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');


	$test[] = '0.1.002';
	function perp_ar_upgrade0_1_002()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_client','currency',array(
			'type' => 'char',
			'precision' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.003';
	}


	$test[] = '0.1.003';
	function perp_ar_upgrade0_1_003()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client','status',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.004';
	}


	$test[] = '0.1.004';
	function perp_ar_upgrade0_1_004()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client','sales_group','sales_type');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client','sales_area',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client',array(
			'fd' => array(
				'client_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'client_num' => array('type' => 'varchar','precision' => '10','nullable' => False),
				'client_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'address' => array('type' => 'int','precision' => '4'),
				'currency' => array('type' => 'char','precision' => '3','nullable' => False),
				'sales_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_since' => array('type' => 'date','nullable' => False),
				'hold_reason' => array('type' => 'int','precision' => '4'),
				'payment_terms' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'discount' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'invoice_branch' => array('type' => 'int','precision' => '4','nullable' => False),
				'user_account' => array('type' => 'int','precision' => '4'),
				'status' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sales_area' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_id'),
			'fk' => array('address' => 'perp_address.address_id','currency' => 'perp_currency.currency_id','sales_type' => 'perp_sales_type.sales_type_id','payment_terms' => 'perp_payment_term.payment_term_id','invoice_branch' => 'perp_client_branch.client_branch_id','user_account' => 'erp_accounts.account_id','sales_area' => 'perp_sales_area.sales_area_id'),
			'ix' => array('client_id','sales_type'),
			'uc' => array('client_id','client_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.005';
	}


	$test[] = '0.1.005';
	function perp_ar_upgrade0_1_005()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_client_account',array(
			'fd' => array(
				'client_account_id' => array('type' => 'auto','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_account_name' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'terms' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'hold_reason' => array('type' => 'int','precision' => '4','default' => '0'),
				'discount_percent' => array('type' => 'decimal','precision' => '4','scale' => '1','nullable' => False,'default' => '0')
			),
			'pk' => array('client_account_id'),
			'fk' => array('client_id' => 'perp_client.client_id','terms' => 'perp_payment_term.payment_term_id'),
			'ix' => array('client_account_id','client_id'),
			'uc' => array('client_account_id')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function perp_ar_upgrade0_1_006()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_account','terms','payment_terms');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_account',array(
			'fd' => array(
				'client_account_id' => array('type' => 'auto','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_account_name' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'payment_terms' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'hold_reason' => array('type' => 'int','precision' => '4','default' => '0'),
				'discount_percent' => array('type' => 'decimal','precision' => '4','scale' => '1','nullable' => False,'default' => '0')
			),
			'pk' => array('client_account_id'),
			'fk' => array('client_id' => 'perp_client.client_id','payment_terms' => 'perp_payment_term.payment_term_id'),
			'ix' => array('client_account_id','client_id'),
			'uc' => array('client_account_id')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function perp_ar_upgrade0_1_007()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_ledger','client_account_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'settled' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'sales_order_id' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','sales_order_id' => 'perp_sales_order.sales_order_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array('trans_id')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function perp_ar_upgrade0_1_008()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipment_num' => array('type' => 'varchar','precision' => '10'),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id','shipment_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function perp_ar_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_client_shipment_detail',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipped_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('shipment_id','work_order_id','stock_id'),
			'fk' => array('shipment_id' => 'perp_client_shipment.shipment_id','work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('shipment_id','work_order_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function perp_ar_upgrade0_1_010()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_shipment_detail','shipment_id','client_shipment_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment_detail',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipped_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('client_shipment_id','work_order_id','stock_id'),
			'fk' => array('client_shipment_id' => 'perp_client_shipment.shipment_id','work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('client_shipment_id','work_order_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function perp_ar_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment_detail',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipped_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('client_shipment_id','work_order_id','stock_id'),
			'fk' => array('client_shipment_id' => 'perp_client_shipment.client_shipment_id','work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('client_shipment_id','work_order_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function perp_ar_upgrade0_1_012()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_shipment','from_location',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipment_num' => array('type' => 'varchar','precision' => '10'),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id','shipment_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function perp_ar_upgrade0_1_013()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_shipment_detail','work_order_id','sales_order_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment_detail',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipped_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('client_shipment_id','sales_order_id','stock_id'),
			'fk' => array('client_shipment_id' => 'perp_client_shipment.client_shipment_id','sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('client_shipment_id','sales_order_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function perp_ar_upgrade0_1_014()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_shipment_detail','quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function perp_ar_upgrade0_1_015()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_shipment','approved_by',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_shipment','approved_date',array(
			'type' => 'date'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipment_num' => array('type' => 'varchar','precision' => '10'),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date')
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id','shipment_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function perp_ar_upgrade0_1_016()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_shipment','shipped_by',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipment_num' => array('type' => 'varchar','precision' => '10'),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id','shipment_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function perp_ar_upgrade0_1_017()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_shipment','client_branch_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipment_num' => array('type' => 'varchar','precision' => '10'),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id','shipment_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function perp_ar_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_client_shipment','shipment_num',array(
			'type' => 'varchar',
			'precision' => '20'
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function perp_ar_upgrade0_1_019()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_client_account_price_list',array(
			'fd' => array(
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_account_id','price_list_id'),
			'fk' => array('client_account_id' => 'perp_client_account.client_account_id','price_list_id' => 'perp_price_list.price_list_id'),
			'ix' => array('client_account_id'),
			'uc' => array(array('client_account_id','price_list_id'))
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.020';
	}


	$test[] = '0.1.020';
	function perp_ar_upgrade0_1_020()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_shipment_detail','stock_id','line_no');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment_detail',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipped_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('client_shipment_id','sales_order_id','line_no'),
			'fk' => array('client_shipment_id' => 'perp_client_shipment.client_shipment_id','sales_order_id' => 'perp_sales_order.sales_order_id','line_no' => 'perp_sales_order_detail.line_no'),
			'ix' => array('client_shipment_id','sales_order_id','line_no'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.021';
	}


	$test[] = '0.1.021';
	function perp_ar_upgrade0_1_021()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_client_account_discount',array(
			'fd' => array(
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_amount' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'discount_percent' => array('type' => 'decimal','precision' => '3','scale' => '2')
			),
			'pk' => array('client_account_id','sales_category_id'),
			'fk' => array('client_account_id' => 'perp_client_account.client_account_id','sales_category_id' => 'perp_sales_category.sales_category_id'),
			'ix' => array('client_account_id','sales_category_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.022';
	}


	$test[] = '0.1.022';
	function perp_ar_upgrade0_1_022()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client',array(
			'fd' => array(
				'client_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'client_num' => array('type' => 'varchar','precision' => '10','nullable' => False),
				'client_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'address' => array('type' => 'int','precision' => '4'),
				'currency' => array('type' => 'char','precision' => '3','nullable' => False),
				'sales_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_since' => array('type' => 'date','nullable' => False),
				'hold_reason' => array('type' => 'int','precision' => '4'),
				'payment_terms' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'discount' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'invoice_branch' => array('type' => 'int','precision' => '4','nullable' => False),
				'user_account' => array('type' => 'int','precision' => '4'),
				'status' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sales_area' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_id'),
			'fk' => array('address' => 'perp_address.address_id','currency' => 'perp_currency.currency_id','sales_type' => 'perp_sales_type.sales_type_id','payment_terms' => 'perp_payment_term.payment_term_id','invoice_branch' => 'perp_client_branch.client_branch_id','user_account' => 'egw_accounts.account_id','sales_area' => 'perp_sales_area.sales_area_id'),
			'ix' => array('client_id','sales_type'),
			'uc' => array('client_id','client_num')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.023';
	}


	$test[] = '0.1.023';
	function perp_ar_upgrade0_1_023()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_account_discount','narrative',array(
			'type' => 'varchar',
			'precision' => '20',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_account_discount','account_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_account_discount',array(
			'fd' => array(
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_amount' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'discount_percent' => array('type' => 'decimal','precision' => '3','scale' => '2'),
				'narrative' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_account_id','sales_category_id'),
			'fk' => array('client_account_id' => 'perp_client_account.client_account_id','sales_category_id' => 'perp_sales_category.sales_category_id','account_id' => 'perp_account.account_id'),
			'ix' => array('client_account_id','sales_category_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.024';
	}


	$test[] = '0.1.024';
	function perp_ar_upgrade0_1_024()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_client_account_discount','discount_percent',array(
			'type' => 'decimal',
			'precision' => '5',
			'scale' => '1'
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.025';
	}


	$test[] = '0.1.025';
	function perp_ar_upgrade0_1_025()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_client_receipt',array(
			'fd' => array(
				'receipt_id' => array('type' => 'auto','nullable' => False),
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoice_id' => array('type' => 'int','precision' => '4'),
				'amount' => array('type' => 'varchar','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'allocation_date' => array('type' => 'date'),
				'allocated_from' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('receipt_id','trans_id','invoice_id'),
			'fk' => array('trans_id' => 'perp_client_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_client_receipt.receipt_id'),
			'ix' => array('receipt_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.026';
	}


	$test[] = '0.1.026';
	function perp_ar_upgrade0_1_026()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_ledger','reference',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.027';
	}


	$test[] = '0.1.027';
	function perp_ar_upgrade0_1_027()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'settled' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'sales_order_id' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'reference' => array('type' => 'text')
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','sales_order_id' => 'perp_sales_order.sales_order_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array('trans_id',array('trans_id','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.028';
	}


	$test[] = '0.1.028';
	function perp_ar_upgrade0_1_028()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'settled' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'sales_order_id' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'reference' => array('type' => 'text')
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','sales_order_id' => 'perp_sales_order.sales_order_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array(array('trans_id','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.029';
	}


	$test[] = '0.1.029';
	function perp_ar_upgrade0_1_029()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_receipt','line_no',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_receipt',array(
			'fd' => array(
				'receipt_id' => array('type' => 'auto','nullable' => False),
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoice_id' => array('type' => 'int','precision' => '4'),
				'amount' => array('type' => 'varchar','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'allocation_date' => array('type' => 'date'),
				'allocated_from' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('receipt_id','trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_client_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_client_receipt.receipt_id','line_no' => 'perp_client_ledger.line_no'),
			'ix' => array('receipt_id','trans_id','line_no'),
			'uc' => array(array('trans_id','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.030';
	}


	$test[] = '0.1.030';
	function perp_ar_upgrade0_1_030()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_receipt',array(
			'fd' => array(
				'receipt_id' => array('type' => 'auto','nullable' => False),
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoice_id' => array('type' => 'int','precision' => '4'),
				'amount' => array('type' => 'varchar','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'allocation_date' => array('type' => 'date'),
				'allocated_from' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('receipt_id','trans_id','invoice_id','line_no'),
			'fk' => array('trans_id' => 'perp_client_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_client_receipt.receipt_id','line_no' => 'perp_client_ledger.line_no'),
			'ix' => array('receipt_id','trans_id','line_no'),
			'uc' => array(array('trans_id','line_no','receipt_id','invoice_id'))
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.031';
	}


	$test[] = '0.1.031';
	function perp_ar_upgrade0_1_031()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_client','payment_terms',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.032';
	}


	$test[] = '0.1.032';
	function perp_ar_upgrade0_1_032()
	{
		// Manually created to add ACL location
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_ar', 'receipt', 0,3)");

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.033';
	}


	$test[] = '0.1.033';
	function perp_ar_upgrade0_1_033()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'sales_order_id' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'reference' => array('type' => 'text')
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','sales_order_id' => 'perp_sales_order.sales_order_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array(array('trans_id','line_no'))
		),'settled');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'reference' => array('type' => 'text')
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','sales_order_id' => 'perp_sales_order.sales_order_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array(array('trans_id','line_no'))
		),'sales_order_id');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_ledger','reference','link');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'link' => array('type' => 'text')
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array(array('trans_id','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.034';
	}


	$test[] = '0.1.034';
	function perp_ar_upgrade0_1_034()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_shipment','client_shipment_id','shipment_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'shipment_num');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'shipper');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'shipper_ref');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'est_ship_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'actual_ship_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'client_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'created_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'created_by');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'ship_to_address');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'from_location');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'approved_by');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'approved_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_client_shipment',array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id')
		),'shipped_by');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_shipment',array(
			'fd' => array(
				'shipment_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('shipment_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('shipment_id'),
			'uc' => array('shipment_id')
		));

		// Change permissions
		$sql = "UPDATE egw_acl SET acl_location = 'shipment' WHERE acl_appname = 'perp_ar' AND acl_location = 'client_shipment'";
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);
		$GLOBALS['egw_setup']->db->insert('egw_acl', array('acl_rights' => 79), 
			array(
				'acl_appname'	=>	'perp_ar',
				'acl_location'	=>	'shipment',
				'acl_account'	=>	0
			),
			__LINE__, __FILE__
		);
		$sql = "UPDATE egw_acl SET acl_location = 'invoice' WHERE acl_appname = 'perp_ar' AND acl_location = 'client_invoice'";
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.035';
	}


	$test[] = '0.1.035';
	function perp_ar_upgrade0_1_035()
	{
		$GLOBALS['egw_setup']->oProc->DropTable('perp_client_shipment_detail');
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_receivable_invoice',array(
			'fd' => array(
				'invoice_id' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('invoice_id'),
			'fk' => array('invoice_id' => 'perp_invoice.invoice_id','client_account_id' => 'perp_client_account.client_account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.036';
	}


	$test[] = '0.1.036';
	function perp_ar_upgrade0_1_036()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_outgoing_shipment_package',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'package_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'package_details' => array('type' => 'varchar','precision' => '50','nullable' => False)
			),
			'pk' => array('shipment_id','line_no','detail_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_shipment_detail.line_no','detail_id' => 'perp_shipment_detail.detail_id'),
			'ix' => array(),
			'uc' => array()
		));

		// Add new permission to pack shipments
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_ar', 'pack', 0,5)");

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.037';
	}


	$test[] = '0.1.037';
	function perp_ar_upgrade0_1_037()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_branch','tax_number',array(
			'type' => 'varchar',
			'precision' => '20'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_branch',array(
			'fd' => array(
				'client_branch_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'branch_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'postal_address' => array('type' => 'int','precision' => '4'),
				'est_delivery_days' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sales_group' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_rep' => array('type' => 'int','precision' => '4'),
				'service_rep' => array('type' => 'int','precision' => '4'),
				'default_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'default_shipper' => array('type' => 'int','precision' => '4'),
				'tax_group' => array('type' => 'int','precision' => '4','nullable' => False),
				'user_account' => array('type' => 'int','precision' => '4'),
				'delivery_address' => array('type' => 'int','precision' => '4'),
				'tax_number' => array('type' => 'varchar','precision' => '20')
			),
			'pk' => array('client_branch_id'),
			'fk' => array('client_id' => 'perp_client.client_id','postal_address' => 'perp_address.address_id','sales_group' => 'perp_sales_group.sales_group_id','sales_rep' => 'erp_accounts.account_id','service_rep' => 'erp_accounts.account_id','default_location' => 'perp_location.location_id','default_shipper' => 'perp_shipper.shipper_id','tax_group' => 'perp_tax_group.tax_group_id','user_account' => 'erp_accounts.account_id','delivery_address' => 'perp_address.address_id'),
			'ix' => array('client_branch_id','client_id'),
			'uc' => array('client_branch_id','tax_number')
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.038';
	}

	$test[] = '0.1.038';
	function perp_ar_upgrade0_1_038()
	{
		$GLOBALS['egw_setup']->oProc->query('INSERT INTO perp_receivable_invoice (invoice_id, client_branch_id, client_account_id) (
				SELECT 
					perp_invoice.invoice_id,
					min(client_branch_id),
					min(client_account_id)
				FROM perp_invoice
				JOIN perp_client_account ON
					perp_invoice.client_id = perp_client_account.client_id
				JOIN perp_client_branch ON
					perp_invoice.client_id = perp_client_branch.client_id
				WHERE invoice_id IN (
					SELECT 
						perp_invoice.invoice_id
					FROM perp_invoice 
					LEFT JOIN perp_receivable_invoice ON
						perp_invoice.invoice_id = perp_receivable_invoice.invoice_id
					WHERE 
						perp_invoice.client_id != 0 AND
					perp_receivable_invoice.client_account_id IS NULL
				) AND
				invoice_id NOT IN (
					SELECT invoice_id FROM perp_receivable_invoice
				)
				GROUP BY perp_client_account.client_id
			)'
		);
		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.039';
	}



	$test[] = '0.1.039';
	function perp_ar_upgrade0_1_039()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_receipt','payment_number',array(
			'type' => 'varchar',
			'precision' => '16'
		));

		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.040';
	}

	$test[] = '0.1.040';
	function perp_ar_upgrade0_1_040() {
		// Add invoice admin (post) rights
		$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = 79 WHERE acl_appname = 'perp_ar' AND acl_location = 'invoice' AND acl_account = 0");

		// Make sure everyone who can post now can still post
		$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = acl_rights + 64 WHERE acl_appname = 'perp_ar' AND acl_location = 'invoice' AND acl_rights > 4");
		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.1.041';
	}

	$test[] = '0.1.041';
	function perp_ar_upgrade0_1_041() {
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_client_ledger',
				'perp_client_receipt',
				'perp_receivable_invoice',
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ar', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2';
	}


function perp_ar_upgrade0_2()
{
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_receipt',array(
		'fd' => array(
			'receipt_id' => array('type' => 'auto','nullable' => False),
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'invoice_id' => array('type' => 'int','precision' => '4'),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'allocation_date' => array('type' => 'date'),
			'allocated_from' => array('type' => 'int','precision' => '4'),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'payment_number' => array('type' => 'varchar','precision' => '16')
		),
		'pk' => array('receipt_id','trans_id','invoice_id','allocated_from','line_no'),
		'fk' => array('trans_id' => 'perp_client_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_client_receipt.receipt_id','line_no' => 'perp_client_ledger.line_no'),
		'ix' => array('receipt_id','trans_id','line_no'),
		'uc' => array(array('trans_id','line_no','receipt_id','invoice_id'))
	));

	return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2.001';
}


function perp_ar_upgrade0_2_001()
{
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_receipt',array(
		'fd' => array(
			'receipt_id' => array('type' => 'auto','nullable' => False),
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'invoice_id' => array('type' => 'int','precision' => '4'),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'allocation_date' => array('type' => 'date'),
			'allocated_from' => array('type' => 'int','precision' => '4'),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'payment_number' => array('type' => 'varchar','precision' => '16')
		),
		'pk' => array('receipt_id','trans_id','invoice_id','allocated_from','line_no'),
		'fk' => array('trans_id' => 'perp_client_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_client_receipt.receipt_id','line_no' => 'perp_client_ledger.line_no'),
		'ix' => array('receipt_id','trans_id','line_no'),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2.002';
}


function perp_ar_upgrade0_2_002()
{
	$GLOBALS['egw_setup']->oProc->query("
		UPDATE egw_acl SET acl_rights = 11
		WHERE acl_appname = 'perp_ar' AND acl_location = 'receipt' AND acl_account = 0
	");

	$GLOBALS['egw_setup']->oProc->CreateTable('perp_receipt_reversal',array(
		'fd' => array(
			'original_id' => array('type' => 'int','precision' => '4'),
			'reversal_id' => array('type' => 'int','precision' => '4'),
			'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'reason' => array('type' => 'varchar','precision' => '255','nullable' => False)
		),
		'pk' => array('original_id','reversal_id'),
		'fk' => array('original_id' => 'perp_client_receipt.receipt_id','reversal_id' => 'perp_client_receipt.receipt_id','account_id' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2.003';
}

// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ar');


function perp_ar_upgrade0_2_003()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_client','client_num',array(
		'type' => 'varchar',
		'precision' => '20',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2.004';
}


function perp_ar_upgrade0_2_004()
{
	$GLOBALS['egw_setup']->oProc->RenameColumn('perp_client_branch','sales_group','sales_type');
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_client_branch',array(
		'fd' => array(
			'client_branch_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'branch_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'postal_address' => array('type' => 'int','precision' => '4'),
			'est_delivery_days' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
			'sales_type' => array('type' => 'int','precision' => '4','nullable' => False),
			'sales_rep' => array('type' => 'int','precision' => '4'),
			'service_rep' => array('type' => 'int','precision' => '4'),
			'default_location' => array('type' => 'int','precision' => '4','nullable' => False),
			'default_shipper' => array('type' => 'int','precision' => '4'),
			'tax_group' => array('type' => 'int','precision' => '4','nullable' => False),
			'user_account' => array('type' => 'int','precision' => '4'),
			'delivery_address' => array('type' => 'int','precision' => '4'),
			'tax_number' => array('type' => 'varchar','precision' => '20')
		),
		'pk' => array('client_branch_id'),
		'fk' => array('client_id' => 'perp_client.client_id','postal_address' => 'perp_address.address_id','sales_type' => 'perp_sales_type.sales_type_id','sales_rep' => 'erp_accounts.account_id','service_rep' => 'erp_accounts.account_id','default_location' => 'perp_location.location_id','default_shipper' => 'perp_shipper.shipper_id','tax_group' => 'perp_tax_group.tax_group_id','user_account' => 'erp_accounts.account_id','delivery_address' => 'perp_address.address_id'),
		'ix' => array('client_branch_id','client_id'),
		'uc' => array('client_branch_id','tax_number')
	));

	return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2.005';
}


function perp_ar_upgrade0_2_005()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_client_account','disabled_date',array(
		'type' => 'date'
	));

	return $GLOBALS['setup_info']['perp_ar']['currentver'] = '0.2.006';
}

