<?php

	class ui_perp_human_resources {
		private $bo;
		private $template;
		public $public_functions = array(
			'index'		=>	True,
			'link_view'	=>	True,
		);

		private $debug = false;

		/**
		*	Array of messages for the user
		*/
		private $messages = array();

		function ui_perp_human_resources() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_human_resources.bo_perp_human_resources');
		}

		function index($content = array()) {
			$staff = $GLOBALS['egw']->acl->check('staff', EGW_ACL_READ, 'perp_human_resources');
			$department = $GLOBALS['egw']->acl->check('department', EGW_ACL_READ, 'perp_human_resources');

			if(isset($content['staff_list']) && $staff) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_human_resources.ui_perp_staff.staff_list'));
			} elseif (isset($content['department_list']) && $department) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_human_resources.ui_perp_department.department_list'));
			}

			$readonly['staff_list'] = !$staff;
			$readonly['department_list'] = !$department;

			// Display
			$this->template->read('perp_human_resources.index');
			$this->template->exec('perp_human_resources.ui_perp_human_resources.index', $data, $select_box_options, $readonly, $preserve);
		}

		public function link_view() {
			$link = $_GET['link_id'];
			list($location, $id) = explode('-', $link);
			if($id) {
				switch($location) {
					case 'STAFF':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_human_resources.ui_perp_staff.staff_edit', 
								'user_id'	=>	$id
							)
						);
						break;
					case 'DEPARTMENT':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_human_resources.ui_perp_department.department_edit', 
								'department_id'	=>	$id
							)
						);
						break;
				}
			}
		}
	}
?>
