<?php

	/**
	 * eGroupWare - Setup
	 * http://www.egroupware.org 
	 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
	 *
	 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
	 * @package perp_human_resources
	 * @subpackage setup
	 * @version $Id: class.db_tools.inc.php 21408 2006-04-21 10:31:06Z nelius_weiss $
	 */


	$phpgw_baseline = array(
		'perp_staff' => array(
			'fd' => array(
				'staff_id' => array('type' => 'auto'),
				'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date'),
				'status' => array('type' => 'int','precision' => '1'),
				'department_id' => array('type' => 'int','precision' => '4'),
				'reports_to' => array('type' => 'int','precision' => '4'),
				'user_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('staff_id'),
			'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		)
	);
