<?php
	require_once(EGW_API_INC.'/xajax.inc.php');

	class ajax_perp_stock {
		
		private $bo;
		private $xajax;

		function ajax_perp_stock() {
			$this->bo = CreateObject('perp_inventory.bo_perp_stock');
			$this->xajax = new xajax();
		}

		function suggest_stock_number($stock_id, $stock_category, $status) {
			$response = new xajaxResponse();

			// Check to see if we're supposed to update the number.  
			// We'll allow 1 change if it's a new item, in case the stock category or status is involved
			$config = config::read('perp_inventory');
			if($stock_id && $config['allow_stock_number_changes'] == 0) {
				// 0 is never update
				return $response->getXML();
			}

			$stock_item = array(
				'stock_id'		=>	$stock_id,
				'stock_category'	=>	$stock_category,
				'status_flag'		=>	$status
			);
			$stock_number = $this->bo->suggest_stock_number($stock_item);
			$result = true;
			if($stock_id) {
				$result = $this->bo->update_number($stock_id, $stock_number);
			}
			if($result) {
				$GLOBALS['egw']->session->appsession($stock_id . ':new_stock_number', 'perp_inventory', $stock_number);
				$response->addScript("
					var stock_num = document.getElementById('exec[stock_num]');
					if(stock_num) {
						var element = stock_num.lastChild;
						stock_num.innerHTML = '<b>$stock_number</b>';
					}"
				);
			}
			return $response->getXML();
		}
	}
?>
