<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_stock.inc.php');

	/**
	*	Generate a list of barcodes for stock items (1 per)
	*	If the barcode for the stock item is set, that code will be used.  Otherwise, the stock code will be used.
	*	
	*/

	class stock_barcodes extends perp_report {

		public function __construct(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_inventory';
			parent::perp_report($parameters);
			$this->template = 'stock_barcodes.odt';

			$this->parameters = $parameters;
		}

		public function get_data($query = array()) {
			$stock_bo = new bo_perp_stock();

			$query['template']	=	false;
			$query['num_rows']	=	-1;

			$stock_bo->get_stock_list(
				$query,
				$stock_list
			);
		
			$report_list = array();
			foreach($stock_list as $key => $value) {
				if(is_numeric($key) && isset($value['stock_id'])) {
					$value['barcode'] = trim($value['barcode']) != "" ? $value['barcode'] : $value['stock_num'];
					$report_list[] = $value;
				}
			}

			// Data
			$data = array(
				'stock'	=>	$report_list,
			);
			return $data;
		}
	}
?>
