<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_inventory.inc.php');

	/**
	*	Accounts receivable invoice
	*/
	class to_order_report extends perp_report {

		public function to_order_report(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_inventory';
			parent::perp_report($parameters);

			$this->template = 'to_order.odt';

			$this->parameters = $parameters;

			// Default parameters
			$this->parameters['options-location_id'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$this->parameters['options-stock_type_flag'] = ExecMethod('perp_inventory.bo_perp_stock.get_stock_types');
		}

		public function get_data($query = array()) {
			$bo_inventory = new bo_perp_inventory();

			$query['to_order'] = true;
			$data = array();
			$bo_inventory->get_inventory($query, $data);
			return array('stock' => $data);
		}
	}
?>
