<?php
	// Required for gl to work properly
	$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_general_ledger (`trans_no`, `trans_type`, `trans_date`, `line_no`, `account`, `amount`, `narrative`) VALUES 0,0,'0',0,0,0,'Null Record'");
	
	// ACLs
	$locations = array(
		'account'	=>	15, 
		'account_group'	=>	15, 
		'account_section'	=>	15, 
		'sequence'	=>	15,
		'acl'		=>	5, 
		'bank_account'	=>	15, 
		'transaction_type'	=>	15,
		'journal'	=>	7,
		'ledger'	=>	3,
		'bank_trans'	=>	3,
		'reconcile'	=>	1,
	);
	// We assume that Admins group is group #2
	$admin = -2;

	foreach ($locations as $location => $perm) {
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_ledger', '$location', 0,$perm)");

		// Give admin rights to everything
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_ledger', '$location', $admin,$perm)");
	}

	// Give admin run rights
	$GLOBALS['egw_setup']->add_acl($application, 'run', $admin);
	
	// Transaction types
	$trans_type = array(
		'Journal',
		'GL - Payment',
		'GL - Receipt',
		'Purchase Order',
		'Purchase Invoice',
		'Purchase Order Delivery',
		'Payment',
		'Sales Order',
		'Sales Invoice',
		'Receipt',
	);

	foreach ($trans_type as $id => $name) {
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_transaction_type (trans_name) VALUES ('" . lang($name) . "')");
	}

	// Sequences
	$sequences = array(
		'Asset',
		'Liability',
		'Equity',
		'Income',
		'Expense'
	);
	foreach($sequences as $id => $sequence) {
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO perp_sequence (sequence_name) VALUES ('" . lang($sequence) . "')");
	}

	if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
		// These tables need to be InnoDB
		$transaction_tables = array(
			'perp_general_ledger',
			'perp_bank_ledger',
		);
		$so_perp_api = CreateObject('perp_api.so_perp_api');
		$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, $transaction_tables);
	}

?>
