<?php
	/**************************************************************************\
	* pERP - perp_ledger                                                       *
	* http://projectERP.org 	                                           *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/

	/* $Id: setup.inc.php,v 1.37 2005/09/20 13:10:24 ralfbecker Exp $ */

	$setup_info['perp_ledger']['name']      = 'perp_ledger';
	$setup_info['perp_ledger']['version']   = '0.2.016';
	$setup_info['perp_ledger']['app_order'] = 11;
	$setup_info['perp_ledger']['enable']    = 1;

	$setup_info['perp_ledger']['author'] = 'Nathan Gray';
 	$setup_info['perp_ledger']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_ledger']['license']  = 'GPL';
	$setup_info['perp_ledger']['description'] = 'The General Ledger (GL) is the core of a company\'s financial records. These records are a summary of "the books", and serve as a permanent track of the history of all financial transactions since day one of the company or since system startup.';
	$setup_info['perp_ledger']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	//$setup_info['perp_ledger']['hooks']['preferences'] = ;
	$setup_info['perp_ledger']['hooks']['admin'] = 'perp_ledger.hook_perp_ledger.admin_hook';
	$setup_info['perp_ledger']['hooks']['sidebox_menu'] = 'perp_ledger.hook_perp_ledger.sidebox';
	

	/* Dependencies for this app to work */
	$setup_info['perp_ledger']['depends'][] = array(
		 'appname' => 'perp_api',
		 'versions' => Array('0.1', '0.2')
	);

	$setup_info['perp_ledger']['tables'] = array('perp_general_ledger','perp_transaction_type','perp_account','perp_account_group','perp_account_section','perp_bank_account','perp_bank_ledger','perp_sequence','perp_eft_account','perp_bank_reconcile');





