<?php
	/**************************************************************************\
	* pERP - perp_manufacturing                                                *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_manufacturing']['name']      = 'perp_manufacturing';
	$setup_info['perp_manufacturing']['version']   = '0.2.012';
	$setup_info['perp_manufacturing']['app_order'] = 14;
	$setup_info['perp_manufacturing']['enable']    = 1;

	$setup_info['perp_manufacturing']['author'] = 'Nathan Gray';
 	$setup_info['perp_manufacturing']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_manufacturing']['license']  = 'GPL';
	$setup_info['perp_manufacturing']['description'] = 'Manufacturing system';
	$setup_info['perp_manufacturing']['note'] = '';

	/* The hooks this app includes, needed for hooks registration */
	//$setup_info['perp_manufacturing']['hooks']['preferences'] = 'perp_manufacturing.hook_perp_manufacturing.preference_menu';
	$setup_info['perp_manufacturing']['hooks'][] = 'settings';
	$setup_info['perp_manufacturing']['hooks']['admin'] = 'perp_manufacturing.hook_perp_manufacturing.admin_hook';
	$setup_info['perp_manufacturing']['hooks']['sidebox_menu'] = 'perp_manufacturing.hook_perp_manufacturing.sidebox';
	$setup_info['perp_manufacturing']['hooks']['search_link'] = 'perp_manufacturing.hook_perp_manufacturing.search_link';
	$setup_info['perp_manufacturing']['hooks']['workflow_agent'] = 'perp_manufacturing.hook_perp_manufacturing.workflow_agent';


	/* Dependencies for this app to work */
	$setup_info['perp_manufacturing']['depends'][] = array(
		 'appname' => 'perp_inventory',
		 'versions' => Array('0.2')
	);

	$setup_info['perp_manufacturing']['tables'] = array('perp_work_order','perp_work_order_detail','perp_work_order_option','perp_build_option','perp_build_option_category','perp_allowed_build_option','perp_bill_of_material','perp_bill_of_material_detail','perp_work_order_bill_of_material','perp_work_center','perp_stock_assembly_serial','egw_wf_agent_perp_build','perp_serial_setup','perp_work_order_bom_change','perp_work_center_location','perp_work_order_retrofit','perp_work_order_option_history','perp_workflow_stock','perp_build_option_exclusion');

