<?php
	/**************************************************************************\
	* pERP - perp_payroll                                          	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$setup_info['perp_payroll']['name']	=	'perp_payroll';
	$setup_info['perp_payroll']['version']   = '0.2.002';
	$setup_info['perp_payroll']['app_order'] = 19;
	$setup_info['perp_payroll']['enable']    = 1;

	$setup_info['perp_payroll']['author'] = 'Nathan Gray';
 	$setup_info['perp_payroll']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_payroll']['license']  = 'GPL';
	$setup_info['perp_payroll']['description'] = 'Payroll module for pERP';
	$setup_info['perp_payroll']['note'] = 'In progress, just a framework for now';

	/* The hooks this app includes, needed for hooks registration */
	$setup_info['perp_payroll']['hooks']['admin'] = 'perp_payroll.hook_perp_payroll.admin_hook';
	$setup_info['perp_payroll']['hooks'][] = 'settings';
	//$setup_info['perp_payroll']['hooks']['search_link'] = 'perp_payroll.hook_perp_payroll.search_link';
	$setup_info['perp_payroll']['hooks']['sidebox_menu'] = 'perp_payroll.hook_perp_payroll.sidebox';
	//$setup_info['perp_payroll']['hooks']['preferences'] = '';
	$setup_info['perp_payroll']['hooks'][] = 'home';

	/**
	*	Dependencies for this app to work 
	*/
	$setup_info['perp_payroll']['depends'][] = array(
		'appname' => 'perp_human_resources',
		'versions' => Array('0.1')
	);

	$setup_info['perp_payroll']['tables'] = array('perp_earning_type','perp_staff_pay_detail','perp_pay_period','perp_pay_stub','perp_pay_stub_note','perp_pay_stub_entry','perp_pay_stub_entry_type','perp_pay_type_ytd','perp_deduction_type','perp_staff_entry_type','perp_accrual_type','perp_accrual_breakpoint','perp_staff_accrual','perp_pay_schedule','perp_income_tax_rate','perp_pay_amendment','perp_payroll_ledger','perp_pay_period_staff');



