<?php
	/**
	* @class question
	* @brief question is the parent step of all steps that are questions(pre_steps)that use common function for pERP Setup Wizard
	* @author John Trudel
	* @version 1.0
	* @date September 2008
	*/
	include_once(EGW_INCLUDE_ROOT . '/perp_setup_wizard/inc/steps/class.perp_setup_step.inc.php');

	class question extends perp_setup_step {

				
		public function question() {
			$this->question_class_name = get_class($this);			
		}
		
		
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
			
						
		}
	
		public function get_permission(){
		
			return parent::get_permission();
		
		}
		
		public function complete_step($content, $question_class_name){
			
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$question_answers = $perp_setup_wizard_config['question_answers'];
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$steps_status_array = $perp_setup_wizard_config['steps_status'];
			if(!($question_answers[$question_class_name] == 2 || $question_answers[$question_class_name] == 3)){
				unset($steps_status_array[$question_class_name]);				
			}else{
				
				$steps_status_array[$question_class_name] = 1;
			}
			config::save_value('steps_status',$steps_status_array,$content['wizard_app_name']);
			
		}
				
	}
?>