<?php
	/**************************************************************************\
	* pERP - perp_timeclock                                          	   *
	* http://projectERP.org                                                    *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/

	$setup_info['perp_timeclock']['name']	=	'perp_timeclock';
	$setup_info['perp_timeclock']['version']   = '0.1.000';
	$setup_info['perp_timeclock']['app_order'] = 8;
	$setup_info['perp_timeclock']['enable']    = 2;

	$setup_info['perp_timeclock']['author'] = 'Nathan Gray';
 	$setup_info['perp_timeclock']['maintainer'] = array(
		'name'  => 'Nathan Gray',
		'email' => 'nathan@goarctic.com'
	);
	$setup_info['perp_timeclock']['license']  = 'GPL';
	$setup_info['perp_timeclock']['description'] = 'Timeclock module for pERP';
	$setup_info['perp_timeclock']['note'] = 'In progress, just a framework for now.  Should take timestamps and create timesheet entries for them, based on some rules like work shifts and breaks.';

	/* The hooks this app includes, needed for hooks registration */
	/*
	$setup_info['perp_timeclock']['hooks']['preferences'] = '';
	*/
	$setup_info['perp_timeclock']['hooks'][] = 'settings';
	$setup_info['perp_timeclock']['hooks']['admin'] = 'perp_timeclock.hook_perp_timeclock.admin_hook';

	/**
	*	Dependencies for this app to work 
	*/
	$setup_info['perp_timeclock']['depends'][] = array(
		'appname' => 'timesheet',
		'versions' => Array('1.4', '1.6', '1.7')
	);
	$setup_info['perp_timeclock']['depends'][] = array(
		'appname' => 'perp_human_resources',
		'versions' => Array('0.1')
	);
	$setup_info['perp_timeclock']['depends'][] = array(
		'appname' => 'perp_payroll',
		'versions' => Array('0.2')
	);

	$setup_info['perp_timeclock']['tables'] = array('perp_timecard');

